




/*-----------------------------------------------------------------------------
 *                   Orangutan-Based  RobotBASIC RROS
 *                      copyright December 2011 by
 *                          John Blankenship
 * 
 * Suggested websites:
 *     http://www.RobotBASIC.com
 *     http://www.pololu.com
 *     http://forum.pololu.com
 *----------------------------------------------------------------------------
 *            Commands             Code
 *            -------------------------                                     */
 #define      rLocate                3
 #define      rForward               6
 #define      rBackward              7
 #define      rTurnRight            12
 #define      rTurnLeft             13
 #define      rCompass              24
 #define      rSpeed                36
 #define      rLookLeft             48
 #define      rLookRight            49
 #define      rGPS                  66
 #define      rBeacon               96
 #define      rCharge              108
 #define      rPen                 129
 #define      rRangeRight          192
 #define      rRangeLeft           193
 //-----------------------------------

 //-----------------------------------
 #define        CalibServoDrive    110
 #define        CalibrateCompass   111
 #define        SetSenseInvMask    112
 #define        SetTurretOffset    113
 #define        SetRotationTime    114   // calibrate for 90 degrees
 #define        SetMoveTime        115   // calibrate for radius distance
 #define        SetLeftStopOffset  116   // used to correct motor mismatch and centering
 #define        SetRightStopOffset 117
 #define        SetTurnStyle       118
 #define        SetSpeed           119
 #define        SetCCdivisor       120   // used for count correction
 #define        SetMotorRamp       121
 #define        SetLowLevelSense   122
 #define        SetHighLevelSense  123
 #define        SetExpanTimeout    124
 #define        SetRobotAngle      125   // compensate for compass alignment
 #define        SetBeaconTime      126
 #define        SetClicksPerDiam   127
 #define        SetClicksPer90     128
                // 129 for rPen 
 #define        TurnToHalfAngle    130
 #define        PlaySound          131   
 #define        TestCommand        132  // 16 bit counts:Left,Right,0 - MSB first
 #define        StartBalance       133
 #define        EnableMotors       134
 #define        EnableCounters     135   // 1/0, counters always used for drift compensation 
 #define        SetSlowDownSpeed   136
 #define        MuteBeaconDet      137
 #define        MotorSetup         138
 #define        SensorSetup        139
 #define        SetReducForRight   140   
 #define        SetReducBackRight  141
 #define        SetReducForLeft    142   
 #define        SetReducBackLeft   143
 #define        SetRROStimeout     144  // motors are stopped if no signal received by timeout
 #define        SetCountDiv        145
 #define        SetSerMotSpeedMult 146
 #define        FindBeacon         147   // argument specifies direction of rotation
 #define        SetBeaconDelay     148
 #define        SetSteerMult       149
 #define        SetServoDir        150
 #define        SetSteerServoDir   151
 #define        SetRobotDiameter   152
 #define        SetTurretWidth     153
 #define        SetMoveToMax       154
 #define        SetMoveToMin       155
 #define        SetSlowDown2       156
 #define        SetPCBcalibrate    157
 #define        RROSversion        158
 #define        Drive              159
 #define        ReadRangers        160
 #define        SetCompassType     161
 #define        ForwardWithFeel    162
 #define        SetBeaconSpeed     163
 /*
 #define        SetArmIndex        162
 #define        WriteArmData       163
 #define        SetHand            164
 #define        MoveArm            165 */


// reserved space for main chip expansion codes

// used only when arm expansion chip is available
 #define        ExpansionSetup     200  // Sends initializing byte
 #define        BecomeArmExpansion 201  // Passes init BITS on to expansion ARM controller
 #define        ReadExpSensors     202  // reads bump, IR, line sensors from external source
 #define        ReadArmSensors     203  // reads line sensors from Arm expansion
 

 // all codes 210-255 are just passed on (if expansion available) with 5 bytes returned

 #define        SetNAVbeacons      230  // initializes NAV (uses upper 3 sense bits)
 #define        ReadBeaconAngles   231 
 #define        ReadArmAnalogs     232  // 2MSB specify #, all 8 bits passed on   
 #define        SetServoNumber     233  // NUM auto increments with following commands
 #define        SetServoPosition   234  // sets current position # to argument, increments #
 #define        SetServoOffset     235  // sets min/max points, increments #
 #define        SetServoSpeed      236  // sets current speed # to argument, increments #
 #define        SetServoMult       237  // controls maximum pulse width
 #define        EnableServos       238  // 1 enables, 0 disables, default is disabled 
 #define        GPSsetup           239
 #define        SetGPShighX        240  // sets starting position
 #define        SetGPSlowX         241  // clears high byte automatically
 #define        SetGPShighY        242
 #define        SetGPSlowY         243  // clears high byte automatically
 #define        ExtSensorSetup     244
 #define        LookSetup          245
 #define        PenSetup           246
 #define        SetArmOutputs      247  // for up to 3 output bits on arm expansion
 #define        SetNAVservoMinHigh 248
 #define        SetNAVservoMinLow  249
 #define        SetNAVservoMaxHigh 250
 #define        SetNAVservoMaxLow  251
 // 252-255 are also echoed and returned, used for future RROS commands
    

#define sei()  __asm__ __volatile__ ("sei" ::)
#define cli()  __asm__ __volatile__ ("cli" ::)
 


// ----------------------------------- 
 #define        CompassClock         4
 #define        CompassData          2
 #define        ServoCtr          1250

 //----------------------------------------------------------------------------
 


#include <C:\Users\John\Documents\AVR\Include\pololu\orangutan.h>

#include <C:\Users\John\Documents\AVR\Include\pololu\math.h>
//#include <C:\Users\John\Documents\RROS Programs\RROSlight\RROSlight\libm.a>
//#include <C:\Users\John\Documents\avr/interrupt.h>

//====================================================================
// initialization of global variables and constants
//====================================================================

#define ON         1
#define COAST      0
#define REVERSE    2
#define BRAKE      3

  int Trig[91]={ 0, 2, 3, 5, 7, 9,10,12,14,16,
                17,19,21,23,24,26,28,29,31,33,
                34,36,37,39,41,42,44,45,47,48,
                50,52,53,54,56,57,59,60,62,63,
                64,66,67,68,69,71,72,73,74,75,
                77,78,79,80,81,82,83,84,85,86,
                87,87,88,89,90,91,91,92,93,93,
                94,95,95,96,96,97,97,97,98,98,
                98,99,99,99,99,100,100,100,100,100,100};

  // 3 octaves of C
  int Notes[22]={0,3817,3401,3330,2857,2551,2272,2024,
                   1903,1701,1515,1432,1276,1136,1012,
                    956, 852, 759, 716, 637, 568, 506};

  int SpeedLeft = 0;           // desired speeds
  int SpeedRight = 0;
  int CurLeft = 0;             // current speeds
  int CurRight = 0;
  int CurDirLeft = 0;          // current wheel directions 
  int CurDirRight = 0;
//  char StandardSpeed;           //  standard speed for all motor movements
  char MotRamp=1;                 // amount to change speed each 10ms interval
  unsigned int LeftCount=0;       // left wheel counter value
  unsigned int RightCount=0;      // right wheel counter value
  char LastLeftCount;           // last value of counter pins
  char LastRightCount;
  int LeftOffset = 0;          // offsets for each wheel to account for physical differences
  int RightOffset = 0;
  char m1,m2;                   // temporary variables
  char CCleft=0;
  char CCright=0;
  int MotorForward;
  int MotorBackward;
  int PulseTimeLeft;
  int PulseTimeRight;
  char SensorBuffer[5]={0,0,0,0,0};                    
  int  TurnStyle = 10;
  int  speed = 50; // standard speed ???
  char SensorMode = 0;
  char CompassEnabled = 0;
  char CountersEnabled = 0;
  char RotTime = 0;
  char RROSmode = 0;
  char MotorType = 0;
  //char HaveCompass = 1;
  char AnalogType = 0;
  int  MoveTime = 50;
  int  RangeServoCtr=1270+90-(2*128);
//  char LPSenabled;
//  int  LPSx=0;
//  int  LPSy=0;
  int  count=0;
  char Beacon1=1;
  char Beacon2=2;
//  char RoomWidth=10;
//  char RoomLength=10;
  int ClicksPerDiam=32;
  int ClicksPer90=18;
  char ClicksPerUnit;
  char RemoteLPS=0;
  char Balance=0;
  char RROSexpansion=0;
  char SerNum=0;
  int SerPos[5]={128,128,128,128,128};
  int CurPos[5]={128,128,128,128,128};
  int SerOffset[5]={128,128,128,128,128};
  int ServoMult[5] = {50,50,50,50,50};
  char SerInc[5]={1,1,1,1,1};
  char SerPin[5] = {0,1,2,4,5};
  char ServosEnabled = 0;
  char MotorsEnabled = 0;
  char LowLevelSense=10;
  char HighLevelSense=20;
  char DistMode;
  char HaveBeaconSensor;
  int  RoomAngle = 0;
  char SlowDownSpeed = 25;
  char IR, Bump, Line;
  int  Samples[21];
  char MyAnalog[6];
  char Battery;
  int  Range;
  int  OldServoAngle;
  int  RobotAngle;
  char CalibMotors;
  int  GPSx=0, GPSy=0;
  char SlowDown = 0;
  int  BeaconTime = 350;
  char MuteBeacon = 1;
  char BalanceMode = 0;
  char CompassType = 0;
  char RightStopOffset=128;
  char LeftStopOffset=128;
  char RROStimeout = 15;  // 1/5 second
  char CCdivisor = 2;
//  char OneServoPulse = 0;
  int RedForRight=0;
  int RedBackRight=0;
  int RedForLeft=0;
  int RedBackLeft=0;
  char CountDiv=1;
  char SerMotSpeedMult=50;
  char ServoEnabled; // remote arm servos
  char Expansion = 0;  // defaults to no expansion hardware available
  char Calibrated = 0;
  char NumAnalog;
  char GPSavail=0;
  char LookAvail=0;
  char PenAvail=0;
  char ExpSensorsAvail=0;
  char ArmAvail=0;
  char Custom1Avail=0;
  char Custom2Avail=0;
  char IsArmExpansion=0;
  char TurretOffset=128;
  char ExpTime=105;
  int  NAVservoMin = 1000;
  int  NAVservoMax = 2000;
  char HaveExpansion = 0;
  char CustomAvail = 0;
  char UseWide = 0;
  char RdBeacon=0;
  char GrBeacon=0;
  int  bd1=7250;
  int  bd2=14500;
  char SteerMult = 72;
  int  ServoDir = 1;
  int  SteerServoDir = 1;
  char RobotDiameter = 0;
  char TurretWidth = 16;
  char SensorsEnabled=0;
  char MoveToMin=25;
  char MoveToMax=50;
  char CompassTime=0;
  char SlowSerial = 0;
  char SenseInvMask=0;
  int  SlowDown2=0;
  char PCBcalibrate = 0;
  char Ramping = 1;
  char DriveDir;
  char DrivePer;
  char CW[]="All code copyright by John Blankenship 7/2012";
  char IgnoreOnce = 0;
  char CWarm = 0;
  char Index = 0;
  char BackDirection = 0;
  int xCur,yCur,zCur;
  int xOffset=0;yOffset=0;
  int xMax,yMax;
  int xMin,yMin;
  char BeaconSpeed=30;

// function prototypes
char ReadPingRanger(void);
void ReadPortData(void);
void tone(long,long);
void changeTone(int,int,int,int);
//void phasor(char);
//void siren(char);
char ConvertShortIR(char);
char ConvertLongIR(char);
void MyDelay(unsigned int);
void MYmsDelay(unsigned int);
void MYusDelay(unsigned int);
void RunMotors(void);
void motors(int,int);
void MoveToAngle(int);
void Calibrate_Compass(char);
void CountWheels(void);
void ReadSamples(char);
void ReadSensors(void);
void PlayNote(unsigned int, int);
void Initialization(void);
void RightMotor(char);
void LeftMotor(char);
void SerialMotorOut(char);
int  Read_Compass(void);
int  Read_Compass2(void);
void Init_Compass2(void);
void InitI2C(void);
void ExpansionSerialOut(char);
char ExpansionSerialIn(void);
void ServoMotors(void);
char WideOn(void);
char NarrowOn(void);
char BeaconOn(void);
char WideOff(void);
char NarrowOff(void);
void CWSerialOut(char);
void SendServoData(char, char);
int  Compare(int, int);
void InitSpeeds(void);
void ReadAnalogSensors(void);
int CWinit = 0; // not initialized
char Array[90]={128,128,128,128,128,128,128,128};
char OffSet[8]={0,0,0,0,0,0,0,0};


//char SeeWide(void);
//char SeeNarrow(void);




void ProcessCommand(char* InputBuffer)
{
   // variables for Sensor Buffers
   char command=InputBuffer[0];  // command from RB
   char argument=InputBuffer[1];
   char i,j,t,bnum;
   unsigned int gr=0,rd=0,grNum=0,rdNum=0; 
   int k,sum,temp1; 
   int temp;
   SensorBuffer[0]=0;
   SensorBuffer[1]=0;
   SensorBuffer[2]=0;
   SensorBuffer[3]=0;
   SensorBuffer[4]=0;
   if( (command>=210)  && HaveExpansion) // remote command
     {
     // echo command and argument to remote processor
     ExpansionSerialOut(command);
     ExpansionSerialOut(argument);
     // wait for 5 bytes and place them in the SensorBuffer
     for(i=0;i<5;i++)
       SensorBuffer[i]=ExpansionSerialIn();
/*     if(command==ReadBeaconAngles)
       {
       // adjust sensor buffer by compass readings

       }*/
     return;
     }
   else
     switch (command)
       {
       //====================================
		  case rLocate:
            
            if(argument==255) SlowSerial = 1;
            if(argument==254) // assume RB9
              {
              tone(200,500);
              // Motor setup
              MotorType = 0; // small DC for 
              CountersEnabled = 1;            
              // SensorSetup:
              SensorMode = 1; // 5 range sensors
              SensorsEnabled=1;
              AnalogType = 4; // SR04
      
         /*     CompassType = 1; // standard compass
              InitI2C();
              Read_Compass();
              Read_Compass();
              Read_Compass(); */
              NumAnalog=5;
              DDRD&=~4; // input for rear digital sensor
              RobotAngle=0;
              // ensure count pins are inputs
              DDRB &= ~3; 
              Initialization();
              MotorsEnabled=1;
              motors(0,0);
              RunMotors();
              MoveToMax = 20;
              MoveToMin = 15;
              BeaconSpeed = 30;
              PCBcalibrate = 1;
              break;
              }
//---------------------
            if(argument==253)  // assume Arlo
              {
              tone(200,500);
              // motor setup
              MotorType = 1; // servo motors
              CountersEnabled = 1;  // Modes 0-2 only
              
              // SensorSetup:
              SensorMode=2;
              SensorsEnabled=1;
              AnalogType = 3; // ping sensors
       /*       CompassType = 1;
              InitI2C();
              Read_Compass();
              Read_Compass();
              Read_Compass(); */             
              NumAnalog=6;
              RobotAngle=0;
              // ensure count pins are inputs
              DDRB &= ~3; 
              Initialization();
              MotorsEnabled=1;
              motors(0,0);
              RunMotors();  
              MoveToMax = 70;
              MoveToMin = 40; 
              BeaconSpeed = 50; 
              LowLevelSense = 10;
              HighLevelSense = 20;         
              break;
            }
          if(argument==252) // assume restart (essentially do nothing)
              break;
          // normal rLocate 
            tone(200,500);
            SpeedLeft = 0;     
            SpeedRight = 0;
            CurLeft = 0;             
            CurRight = 0;
            CurDirLeft = 0;          // current wheel directions 
            CurDirRight = 0;
            MotRamp=1;                 // amount to change speed each 10ms interval
            LeftCount=0;       // left wheel counter value
            RightCount=0;      // right wheel counter value
            LastLeftCount=0;           // last value of counter pins
            LastRightCount=0;
            LeftOffset = 0;          // offsets for each wheel to account for physical differences
            RightOffset = 0;
            CCleft=0;
            CCright=0;
            TurnStyle = 10;
            speed = 50; 
            SensorMode = 0;
            CompassEnabled = 0;
            CountersEnabled = 0;
         RotTime = 4;
            RROSmode = 0;
            MotorType = 0;
           // HaveCompass = 0;
            AnalogType = 0;
         MoveTime = 12;
            RangeServoCtr=1270+90-(2*128);
            count=0;
            ClicksPerDiam=32;
            ClicksPer90=15;
            ClicksPerUnit=2;
            RemoteLPS=0;
         Balance=0;
            RROSexpansion=0;
            SerNum=0;
            ServosEnabled = 0;
            MotorsEnabled = 0;
            LowLevelSense=10;
            HighLevelSense=20;
            SlowDownSpeed = 25;
            CalibMotors = 0;
            BeaconTime = 350;
            MuteBeacon = 1;
         BalanceMode = 0;
            CompassType = 0;
            RightStopOffset=128;
            LeftStopOffset=128;
            RROStimeout = 15;  // 1/5 second
            CCdivisor = 2;
            RedForRight=0;
            RedBackRight=0;
            RedForLeft=0;
            RedBackLeft=0;
            CountDiv=1;
            SerMotSpeedMult=50;
            ServoEnabled=0; // remote arm servos
            Expansion = 0;  // defaults to no expansion hardware available
            Calibrated = 0;
            GPSavail=0;
            LookAvail=0;
            PenAvail=0;
            ExpSensorsAvail=0;
            ArmAvail=0;
            Custom1Avail=0;
            Custom2Avail=0;
            IsArmExpansion=0;
            TurretOffset=128;
            ExpTime=105;
            NAVservoMin = 1000;
            NAVservoMax = 2000;
            HaveExpansion = 0;
            CustomAvail = 0;
            UseWide = 0;
            RdBeacon=0;
            GrBeacon=0;
            bd1=7250;
            bd2=14500;
            SteerMult = 72;
            ServoDir = 1;
            SteerServoDir = 1;
            RobotDiameter = 0;
            TurretWidth = 16;
            SensorsEnabled=0;
            MoveToMin=15;
            MoveToMax=60;
            CompassTime=0;
            SlowDown2 = 0;
            PCBcalibrate = 0;
            Ramping  = 1;
            IgnoreOnce = 0;
		  break;



// end of rLocate
       //====================================
		  case rForward:

            BackDirection = 0;
            Ramping=1;
		    if (argument==1)
               motors(speed,speed);
            if (argument==0)
               {
			   motors(0,0);
               //for(k=0;k<10;k++)
                 RunMotors();
               }
        	if (argument>1)
			   {
               CCleft=CCright=0;
               if(CountersEnabled)
                 {
                 motors(0,0);
                 //for(k=0;k<10;k++)  // ensure robot has stopped moving ************************
                   RunMotors();
                 LastLeftCount  = PINB & 0b00000001;
                 LastRightCount = PINB & 0b00000010;
                 LeftCount=0;
                 RightCount=0;                
                 motors(speed,speed);
                 t=0;
                 while((LeftCount/CountDiv)<((ClicksPerDiam*argument)/40))
                   {
                   if((LeftCount/CountDiv)>(  ((ClicksPerDiam*argument)/40) - (ClicksPerDiam/2)))
                      {motors(SlowDownSpeed,SlowDownSpeed);}
                   if(SlowDown2 && ((LeftCount/CountDiv)>(((ClicksPerDiam*argument)/40)-(ClicksPerDiam/4))))
                      {motors(SlowDown2,SlowDown2);}
                   RunMotors();
                   t++;
                   if (t>1500)
                     break;
                   }
                 motors(0,0);
                 for(k=0;k<20;k++)
                   RunMotors();
                 }
               else
                 {		   
			     motors(speed,speed);
			     for(k=0;k<(MoveTime*argument)/6;k++)    
                   RunMotors();
                 motors(0,0);
                 for(k=0;k<20;k++)
                   RunMotors();
                 }
			   }
   	 			
		  break;
       //====================================
		  case rBackward:
            BackDirection = 0;
            Ramping=1;
		    if (argument==1)
               motors(-speed,-speed);
            if (argument==0)
               {
			   motors(0,0);
               //for(k=1;k<=30;k++)
                 RunMotors();
               }
        	if (argument>1)
			   {
               CCleft=CCright=0;
               if(CountersEnabled)
                 {
                 motors(0,0);
                 for(k=0;k<10;k++)                
                   RunMotors();
                 LeftCount=0;
                 RightCount=0;
                 LastLeftCount  = PINB & 0b00000001;
                 LastRightCount = PINB & 0b00000010;
                 motors(-speed,-speed);
                 t=0;
                 while((LeftCount/CountDiv)<((ClicksPerDiam*argument)/40))
                   {
                   if((LeftCount/CountDiv)>(((ClicksPerDiam*argument)/40)-(ClicksPerDiam/2)))
                      {motors(-SlowDownSpeed,-SlowDownSpeed);}
                   if(SlowDown2 && ((LeftCount/CountDiv)>(((ClicksPerDiam*argument)/40)-(ClicksPerDiam/4))))
                      {motors(-SlowDown2,-SlowDown2);}
                   t++;
                   if (t>1500)
                     break;
                   RunMotors();
                   }
                 motors(0,0);
                 for(k=1;k<=20;k++)
                   RunMotors();
                 }
               else
                 {		   
			     motors(-speed,-speed);
			     for(k=0;k<(MoveTime*argument)/6;k++)      
                   RunMotors();
                 }
               motors(0,0);
               for(k=1;k<=20;k++)
                 RunMotors();
			   }
		  break;
      //====================================
		  case rTurnRight:
            if(argument!=1)
              BackDirection = 0;
            //Ramping=1;
            if(MotorType==3)
              {
              // steerable robot
              if(CurDirRight!=MotorForward)
                {
                // changing directions, must go to zero first
                SpeedRight=0;
                while((CurRight!=SpeedRight))
                  RunMotors();
                }
              SpeedRight=argument; // new angle
              CurDirRight = MotorForward;
              break;
              }
		    if (argument==1)
			  { 
              CCleft=CCright=0; 
			  if (TurnStyle==100)
                 {
                 BackDirection = 0;
			     motors(ServoDir*speed,-speed*ServoDir);
                 }
			  else
                 {
                 if(BackDirection)
                   motors(-ServoDir*speed,-ServoDir*(TurnStyle*speed)/100);
                 else
			       motors( ServoDir*speed, ServoDir*(TurnStyle*speed)/100);
                 //RunMotors();
                 }
              }
            if (argument==0)
               {
			   motors(0,0);
               //for(k=1;k<=30;k++)
                 RunMotors();
               }
        	if (argument>1)
			   {
               //Ramping=0;;
               CCleft=CCright=0;
               if(CountersEnabled)
                 {
                 motors(0,0);
                 RunMotors();
                 LeftCount=0;
                 RightCount=0;
                 LastLeftCount  = PINB & 0b00000001;
                 LastRightCount = PINB & 0b00000010;                 
                 motors(ServoDir*speed,-speed*ServoDir);
                 temp=0;
                 while((LeftCount/CountDiv)<((ClicksPer90*argument)/90))
                   {
                   temp++;
                   if((LeftCount/CountDiv)> (ClicksPer90*argument/90-(ClicksPer90)))
                      {motors(ServoDir*SlowDownSpeed,-SlowDownSpeed*ServoDir);}
                   if(SlowDown2 && ((LeftCount/CountDiv)> (ClicksPer90*argument/90-(ClicksPer90/3))))
                      {motors(ServoDir*SlowDown2,-SlowDown2*ServoDir);}
                   if (temp>500) 
                     break;
                   RunMotors();
                   }
                 }
               else
                 {		   
			     motors(ServoDir*speed,-speed*ServoDir);
			     for(k=0;k<(RotTime*argument)/25;k++)      
                   RunMotors();
                 }
               motors(0,0);
               for(k=1;k<=20;k++)
                 RunMotors();
			   }
		  break;
      //====================================
		  case rTurnLeft:
            if(argument!=1)
              BackDirection = 0;
            if(MotorType==3)
              {
              // steerable robot
              if(CurDirRight!=MotorBackward)
                {
                // changing directions, must go to zero first
                SpeedRight=0;
                while((CurRight!=SpeedRight))
                  RunMotors();
                }
              SpeedRight=argument; // new angle
              CurDirRight = MotorBackward;
              break;
              }
		    if (argument==1)
			  {  
              IgnoreOnce=0;
              CCleft=CCright=0;
              //Ramping=0;
			  if (TurnStyle==100)
                 {
			     motors(-speed*ServoDir,speed*ServoDir);
                 BackDirection = 0;
                 }
			  else
                 {
                 if (BackDirection)
                   motors(-ServoDir*(TurnStyle*speed)/100,-speed*ServoDir);
                 else
			       motors(ServoDir*(TurnStyle*speed)/100,speed*ServoDir);
                 }
              }
            if (argument==0)
               {
			   motors(0,0); 
               RunMotors();
               }          
        	if (argument>1)
			   {
               //Ramping=0;
               motors(0,0);
               RunMotors();
               LeftCount=0;
               RightCount=0; 
               CCleft=0;
               LastLeftCount  = PINB & 0b00000001;
               LastRightCount = PINB & 0b00000010; 
               temp=0;             
               if(CountersEnabled)
                 {
                 motors(-speed*ServoDir,speed*ServoDir);
                 //temp=LeftCount/CountDiv;
                 while((LeftCount/CountDiv)<((ClicksPer90*argument)/90))
                   {
                   temp++;
                   if((LeftCount/CountDiv)> (ClicksPer90*argument/90-(ClicksPer90)))
                      {motors(-SlowDownSpeed*ServoDir,SlowDownSpeed*ServoDir);}
                   if(SlowDown2 && ((LeftCount/CountDiv)> (ClicksPer90*argument/90-(ClicksPer90/3))))
                      {motors(-SlowDown2*ServoDir,SlowDown2*ServoDir);}
                   if (temp>500)
                     break;
                   RunMotors();
                   }
                 }
               else
                 {		   
			     motors(-speed*ServoDir,speed*ServoDir);
			     for(k=0;k<(RotTime*argument)/25;k++)      
                   RunMotors();
                 }
               motors(0,0);
               for(k=1;k<=20;k++)
                 RunMotors();
			   }
		  break;
      //====================================
		  case rSpeed:
		    // ignore rSpeed commands
		  break;
      //====================================
		  case rCompass:
		    sum=Read_Compass();
//sum=Read_Compass();
            SensorBuffer[3]=sum>>8;
			SensorBuffer[4]=sum&255;
		  break;
      //====================================
          case rGPS:
            ExpansionSerialOut(command);
            ExpansionSerialOut(argument);
            for(i=0;i<5;i++)
              SensorBuffer[i]=ExpansionSerialIn();
            return;
          break;
     //====================================
          case rLookLeft:
            ReadSensors();
            ExpansionSerialOut(command);
            ExpansionSerialOut(argument);
            for(i=0;i<5;i++)
              {
              if(i==4)
                SensorBuffer[4]=ExpansionSerialIn();
              else
                ExpansionSerialIn();
              }
            return;
          break;
      //====================================
          case rLookRight:
            ReadSensors();
            ExpansionSerialOut(command);
            ExpansionSerialOut(argument);
            for(i=0;i<5;i++)
              {
              if(i==4)
                SensorBuffer[4]=ExpansionSerialIn();
              else
                ExpansionSerialIn();
              }
            return;
          break;
      //====================================
          case rPen:
            ExpansionSerialOut(command);
            ExpansionSerialOut(argument);
            for(i=0;i<5;i++)
              ExpansionSerialIn();
          break;
      //====================================
		  case rBeacon:
            ReadSensors();
            DDRD &= ~16; // ensure it is an input
            delay_ms(1);
		    if ((PIND&16) && (PIND&16))   // it it happens to be High (NO BEACON) now
			  delay_us(bd2);           // wait and try again
		    if (!(PIND&16) && !(PIND&16))
			  {
              // some beacon found
			  if (argument>0)
			    {
			    // Beacon detected, now see which one
			    // first wait till beacon signal stops
			    while (!(PIND&16) || !(PIND&16));
			    // pause has started, so count the time till it starts again
                delay_us(bd1);
			    for (i=1;i<=15;i++)
			      {
				  delay_us(500-7); //(247-4);
				  if (!(PIND&16))
				    break;
				  }
                if (i==argument)
			      SensorBuffer[4]=1; // true (found it)
                }
              else
			    SensorBuffer[4]=1; // return True for ANY beacon 
			  }
            if(MuteBeacon)
               {
               DDRD |= 16;    // make output and
               PORTD &= ~16;  // ground
               }
            return;
		  break;
      //====================================
		 case rCharge:
           ReadSensors();
           set_analog_mode(MODE_8_BIT);
           // read battery
           if((NumAnalog==6)&&(AnalogType!=3))
             {
             PORTD |= 4; // turn relay on with a one
             delay_ms(400);  
             Battery = analog_read(7);
             PORTD &= ~4; // turn relay off with a zero
             }
           else
             {
             Battery = analog_read(7);
		   //battery=battery/52;
		   //if (battery>100) battery=100;
		   //SensorBuffer[3]=battery>>8;
             }
		   //SensorBuffer[4]=Battery>>1;
           SensorBuffer[4]=((int)Battery*10)/25;
           return;
		 break;
     //====================================
		 case rRangeRight:
           ReadSensors();
		   if(SensorMode==0) // digital with turret
            {
		    if (OldServoAngle!=argument)
		      {
		      DDRD |= 4;          // set pin to output for servo control
              for(i=0;i<30;i++) // do enough pulses to ensure movement
			    {
			    PORTD |= 4;  // pulse line high
				temp = RangeServoCtr-((10*TurretWidth*argument)/18)+TurretOffset*2;
			    delay_us(temp);
			    PORTD &= ~(4); // return to low
			    delay_us(40000-temp);
				}
			  OldServoAngle=argument;
			  delay_ms(20);
			  }
            // read ranging sensor
            if(AnalogType<3)
              {
              ReadSamples(6);
              Range = Samples[5];
              if(AnalogType==0) Range= ConvertShortIR(Range);
              if(AnalogType==1) Range= ConvertLongIR(Range);             
              }
             else
              Range = ReadPingRanger(); 
             //if(RobotDiameter) Range= (Range*40)/RobotDiameter;          
            }
           else  // VSS with virtual ranger
            {
            if(argument<23)
              {
              if (argument==1)
                {
                //use rear
                Range=MyAnalog[5];
                }
              else
                {
                // use front
                Range=MyAnalog[2];
                //if(RobotDiameter) Range= (Range*40)/RobotDiameter;
                }
              }
            else 
              if(argument<68)
                {
                // use angled right
                Range=MyAnalog[1];
                //if(RobotDiameter) Range= (Range*40)/RobotDiameter;
                }
              else
                  {
                  // use right sensor
                  Range = MyAnalog[0];
                  }                
            }
            if(argument==180) Range=MyAnalog[5];
            SensorBuffer[4]=Range;
            if(RobotDiameter) 
              {
              Range= (Range*40)/RobotDiameter;
              SensorBuffer[3] = (Range>>8)&255;
              SensorBuffer[4] = Range&255;
              }		    
            return; // sensors already read
		 break;
     //====================================
		 case rRangeLeft:
           ReadSensors();
		   if(SensorMode==0) // digital with turret
            {
		    if (-OldServoAngle!=argument)
		      {
		      DDRD |= 4;          // set pin to output for servo control
              for(i=0;i<30;i++) // do enough pulses to ensure movement
			    {
			    PORTD |= 4;  // pulse line high
				temp = RangeServoCtr+((10*TurretWidth*argument)/18)+TurretOffset*3;
			    delay_us(temp);
			    PORTD &= ~(4); // return to low
			    delay_us(40000-temp);
				}
			  OldServoAngle=-argument;
			  delay_ms(20);
			  }
            // read ranging sensor
            if(AnalogType<3)
              {
              ReadSamples(6);
              Range = Samples[5];
              if(AnalogType==0) Range= ConvertShortIR(Range);
              if(AnalogType==1) Range= ConvertLongIR(Range); 
              }
             else
              Range = ReadPingRanger(); 
             //if(RobotDiameter) Range= (Range*40)/RobotDiameter;          
            }           
          else  // analog with virtual ranger
            {
            if(argument<23)
              {
              //front
              Range=MyAnalog[2];
              //if(RobotDiameter) Range= (Range*40)/RobotDiameter;
              }
            else 
              if(argument<68)
                {
                // use angled right
                Range=MyAnalog[3];
                //if(RobotDiameter) Range= (Range*40)/RobotDiameter;
                }
              else
                  {
                  //use left
                  Range=MyAnalog[4];
                  }            
            }
		    SensorBuffer[4]=Range;
            if(RobotDiameter) 
              {
              Range= (Range*40)/RobotDiameter;
              SensorBuffer[3] = (Range>>8)&255;
              SensorBuffer[4] = Range&255;
              }	
            return;
		 break;

          // The following commands are issued from RobotBASIC through the rCommand statement
      //====================================
          case MotorSetup:
             MotorType = argument&7;
             /*  MODES
                 DC              0
                 Normal Servo    1
                 Simple Serial   2
                 Steerable Robot 3   (servo controlled steering, servo drive)
                 Meccanum Wheels 4   (simple serial control of 2 RoboClaw controllers, 4 wheels)
                 ....
                 Arm Mode        7   (5 servos run instead of drive motors)
             */
             CountersEnabled = (argument&8)>>3;  // Modes 0-2 only
             BalanceMode = (argument&16)>>4; // future use 

             Initialization(); // resets defaults
             MotorsEnabled=1;
             motors(0,0);
             RunMotors();
          break;
      //====================================
          case SensorSetup:
             SensorsEnabled=1;
             AnalogType = argument&7;
             CompassType = (argument&24)>>3; //56
             if(CompassType==1) 
                {
                InitI2C();
                Read_Compass();
                Read_Compass();
                Read_Compass();
                }
             if(CompassType==2)  Init_Compass2();
             SensorMode = (argument>>6)&3;
             if(AnalogType==4)
               {
               NumAnalog=5;
               SensorMode=1;
               }
             if((SensorMode==1) &&(AnalogType!=4)) 
               {
               NumAnalog=5;
               DDRD&=~4; // input for rear digital sensor
               }
             if(SensorMode==2) 
               {
               NumAnalog=6;
               if(AnalogType<3) 
                 DDRD |= 4;  // output for relay control (not needed for PING sensors)
               }
             if(SensorMode==0) //&& (AnalogType!=4)) // digital perimeter sensors with turret
               {
               NumAnalog=0;
               DDRC &= ~15;
               if(AnalogType!=3) //not PING ranger
                 DDRD &= ~128;   // make input for 5th rFeel()
               // set up port as output for range servomotor
               DDRD |= 4; // output for turret servo
               // center turret
               temp = RangeServoCtr+2*TurretOffset;
               for(i=0;i<30;i++) // do enough pulses to ensure movement
			     {
			     PORTD |= 4;  // pulse line high                
				 delay_us (temp);
			     PORTD &= ~(4); // return to low
			     delay_us(40000-temp);
				 }
			   OldServoAngle=0;
                 
			   }
             if((AnalogType==2)  && (SensorMode>0))
               {
               // Make pin output to allow Pulse for Ultrasonic Trigger
               DDRD |= 128; // make output port
               PORTD &= ~128; // start low
               }             
            RobotAngle=0;
            // ensure count pins are inputs
            DDRB &= ~3; 
            if((AnalogType<3) && (SensorMode==2))
              {
              // relay is necessary
              DDRD |=4;    // make pin output
              PORTD &= ~4; // turn relay off with a zero
              }
          break;
      //====================================
 		  case PlaySound:    // remove some and add notes, add length
            if((argument&31)<22)
              PlayNote(Notes[argument&31],argument>>5);
            else
	         switch ((argument&31)-21)
	          {
		      case 1:  //22: blip 1
		        changeTone(200,2800,5,200);
		      break;

              case 2:  //23: blip 2
		        changeTone(2800,200,5,200);
		      break;

              case 3:  //24: init
		        tone(200,500);
              break;

              case 4:  //25: low tone 
		       tone(50,500);
		      break;

              case 5:  //26: BeepBeep
		        tone(1000,100);
		        delay_ms(50);
		        tone(1000,100);
		      break;

              case 6:  //27: BeepBeepBeep
		        tone(1000,100);
		        delay_ms(50);
		        tone(1000,100);
		        delay_ms(50);
		        tone(1000,100);
              break;

		      case 7:  //28: phasor
		        for(i=0;i<5;i++)
                  {
	              changeTone(500,200,5,100);
	              changeTone(200,500,5,100);
	              }
              break;

              case 8: //29: siren 1
		        for(i=0;i<5;i++)
                  {
	              changeTone(1000,500,10,200);
	              changeTone(500,1000,10,200);
	              }
              break;

              case 9: //30: siren 2
		        for(i=0;i<5;i++)
         	      changeTone(500,1000,10,200);
              break;       
      
              case 10: //31: siren 4
		        for(i=0;i<5;i++)
	              changeTone(200,2000,30,500);
              break;
			  }
		  break;
      //====================================
		  case CalibrateCompass:
            if (CompassType)
            {
            if (!argument)
              {
              argument=10+(SlowDownSpeed*2);
              if (argument>95)
                argument = 95;
              }
            Calibrate_Compass(argument);
            }
		  break;
      //====================================
		  case SetSenseInvMask:
		    SenseInvMask=argument;
		  break;
      //====================================
		  case SetTurretOffset:
		    TurretOffset=argument;		    
		  break;
      //====================================
		  case SetRotationTime:
		    RotTime=argument;
		  break;
      //====================================
		  case SetMoveTime:
		    MoveTime=argument;    
		  break;
      //====================================
		  case SetReducForLeft:
            RedForLeft = argument;
            if(RedForLeft>100) RedForLeft=100;
          break;
      //====================================
          case SetReducForRight:
            RedForRight = argument;
            if(RedForRight>100) RedForRight=100;
          break;
      //====================================
          case SetReducBackLeft:
            RedBackLeft = argument;
            if(RedBackLeft>100) RedBackLeft=100;
          break;
      //====================================
          case SetReducBackRight:
            RedBackRight = argument;
            if(RedBackRight>100) RedBackRight=100;
          break;
      //====================================
          case SetRightStopOffset:
            RightStopOffset=argument;
          break;
      //====================================
          case SetLeftStopOffset:
            LeftStopOffset=argument;
          break;
      //====================================
		  case SetTurnStyle:
		    TurnStyle=argument;
			if (TurnStyle>100) TurnStyle=100;
		  break;
      //====================================
          case SetCCdivisor:
            CCdivisor = argument;
          break;
      //====================================
          case SetCountDiv:
            CountDiv = argument;
          break;
      //====================================
          case SetSerMotSpeedMult:
            SerMotSpeedMult=argument;
            if(SerMotSpeedMult>127) SerMotSpeedMult=127;
          break;
      //====================================
		  case SetLowLevelSense: 
            LowLevelSense = argument;
		  break;
      //====================================
		  case SetHighLevelSense:
		    HighLevelSense=argument;
          break;
      //====================================
		  case SetSpeed:
             if (argument>127) argument=127;
		     speed=argument;
		  break;
      //====================================
          case SetExpanTimeout:

          break;
      //====================================  
		  case FindBeacon:
		     // argument specifies direction
               DDRD &= ~16; // make input
               delay_ms(1);
			   temp1=0;
			   if (argument==1)
			     {
		         motors(BeaconSpeed,-BeaconSpeed ); // turn right
				 }
               else
			     {
		         motors(-BeaconSpeed,BeaconSpeed); // turn left
				 }
			   while(BeaconOn())  // move away from current beacon
                 RunMotors();
               for(temp=0;temp<BeaconTime;temp++) // enough time for at least one FULL revolution
			     {
				 RunMotors();
                 if(BeaconOn())
                   break;
				 }
               motors(0,0);
               RunMotors();
              i=0;       // assume no beacon found
		      if ((PIND&16)&&(PIND&16))   // it it happens to be High now
			    delay_us(bd2);           // wait and try again
		      if (!(PIND&16)&& !(PIND&16))
			    {
			    // Beacon detected, now see which one
			    // first wait till beacon signal stops
			    while (!(PIND&16)&&!(PIND&16));
                delay_us(bd1);
			    for (i=1;i<=15;i++)
			      {
				  delay_us(500-7);
				  if (!(PIND&16))
				    break;
				  }
                }
             if(i==16) i=0;
			 SensorBuffer[4]=i;
             if(MuteBeacon)
               {
               DDRD |= 16;    // make output and
               PORTD &= ~16;  // ground
               }
		  break;
      //====================================
		  case TurnToHalfAngle:
		     MoveToAngle(argument*2);
		  break;
      //====================================
          case ReadArmSensors:
            if(!IsArmExpansion) return;  // only used by arm controller
            // used by Arm Expansion - reads appropriate Sense bits and returns in byte 2
            // maybe 4 more or 7 more (sense 0 is obtained from main RROS
            // read the 4 always available
//new
            //if (CWarm)
            //  DDRD&=~0b10010000;
            //else
              DDRD&=~0b10010100; // make input port 
            DDRC&=~1;          // make input
            i = ((PIND>>1)&2) | ((PIND>>2)&4) | ((PIND>>4)&8) | ((PINC<<4)&16);         
            if(argument==1) // 7 available so get 2 more
              i |= ((PINC<<4)&96);
            SensorBuffer[2]=i;
            delay_ms(1);
            // just return, and since this is the ArmSensorExpansion the output
            // will be done over the RightMotor serial port
            return;
          break;
      //====================================
          case SetClicksPerDiam:
            ClicksPerDiam = argument;
          break;
      //====================================
          case SetClicksPer90:
            ClicksPer90 = argument;
          break;
      //====================================
          case StartBalance:
            Balance = argument;
          break;
      //====================================
          case ExpansionSetup:
            GPSavail=(argument&1);
            LookAvail=(argument>>1)&1;
            PenAvail=(argument>>2)&1;
            ExpSensorsAvail=(argument>>3)&1;
            ArmAvail=(argument>>4)&3; // 0:NA, 1:Normal, 2:with 3 out, 3:with NAV assist
            CustomAvail=(argument>>6)&1;

            // serial port must be setup for ANY expansion device
            if(argument)  // at least one expansion
              {
              HaveExpansion = 1; // at least one expansion available
              DDRB|=(1<<5);  // setup xmit pin
              PORTB|=(1<<5);
              DDRB&=~(1<<4);  // setup rec pin
              delay_ms(10);
              }
            if(ArmAvail)
              {
              // notify external controller that it is an arm controller
              ExpansionSerialOut(BecomeArmExpansion); 
              ExpansionSerialOut(ArmAvail); //0: normal, 1:with 3 outputs, 2: includes NAV assist
              delay_ms(10); // wait for expansion to initialize
              for(i=0;i<5;i++)
                SensorBuffer[i]=ExpansionSerialIn();
              return;
              }
          break;
      //====================================
          case BecomeArmExpansion:
            IsArmExpansion = argument;
            MotorType=7;  // servo motors for arm
            //DDRB   |=  0b00110111; // set servo pins to output
            //PORTB  &= ~0b00110111; // servo data to low for start
            DDRD   &= ~0b10010100; // to input for sense bits 1,2,3
            DDRC   &= ~0b00000001; // sense bit 4
            RightMotor(COAST); // initialize serial out port
            delay_ms(200); // give host RROS time to prepare
            if(argument==1)
              {
              // normal arm expansion
              DDRC &= ~0b00000110; // input for sense 5,6 (total 7 sense)
              }
            if(argument==2)
              {
              // 3 bits of output (only 5 sense) serial out is the 3ed output line
              DDRC |= 0b00000110;
              DDRD |= 0b00000010;
              }
            if(argument==3)
              {
              // arm expansion with NAV assist (only 5 sense)
              DDRC &= ~0b00000110;  // 2 input bits for beacons
              // serial out provides 1 output for servomotor
              // IF THIS IS A PROBLEM WE WILL USE THE LEFT MOTOR OUTPUT
              }
            delay_ms(100);
            return;
          break;
      //====================================
          case ReadArmAnalogs:
            // cannot get here unless this is an ArmExpansion
            set_analog_mode(MODE_8_BIT);
            for(i=0,j=3;i<5;i++,j++)
              SensorBuffer[i]=analog_read(j);
            return; // sends data back by RightMotor serial port
                    // when received the data echoed over the wireless device
                    // return necessary to keep normal sensors from being read
          break;
      //====================================
          case SetArmOutputs:
            // lower 3 bits of argument contain output data
            // BIT 0 always available on PD1
            // Bits 1 and 2 on PC1 and PC2 but only in the output mode
            // LSB always available so do it first
            //DDRD |= 2;
            if(argument&1)
              {
              //LeftMotor(COAST);
              PORTD |= 1;
              }
            else
              {
              //LeftMotor(BRAKE);
              PORTD &= ~1;
              }
            if(ArmAvail==2) // all  outputs available
              {
              // so do two MSBits
              PORTC |= (argument&0b00000110);
              PORTC &= (argument|0b11111001); 
              }
          break;
      //====================================
          case TestCommand:
            SensorBuffer[0]=argument;
            for(i=1;i<5;i++)
              SensorBuffer[i]=i;
            return; // prevents sensor reading from overwriting buffer
          break;
      //====================================
          case SetServoNumber:
            SerNum = argument;
            if(SerNum>4) SerNum=0; // all out of range set to zero
          break;
      //====================================
          case SetServoPosition:
            SerPos[SerNum++]=argument;
            if(SerNum>4) SerNum=0;
          break;
      //====================================
          case SetServoOffset:
            SerOffset[SerNum++]=argument;
            if(SerNum>4) SerNum=0;
          break;
      //====================================
          case SetServoSpeed:
            SerInc[SerNum++]=argument;
            if(SerNum>4) SerNum=0;
          break;
      //====================================
          case SetServoMult:
            ServoMult[SerNum]=argument;
            if(ServoMult[SerNum]>100)
              ServoMult[SerNum]=100;
            SerNum++;
            if(SerNum>4) SerNum=0;
          break;
      //====================================
          case EnableServos:
            ServosEnabled = argument;
            if(argument)
              for(j=0;j<5;j++)
                CurPos[j]=SerPos[j];        
          break;
      //====================================
          case EnableMotors:
            MotorsEnabled = argument;
          break;
      //====================================         
          case EnableCounters:
            CountersEnabled = argument;
          break;
      //====================================
          case SetRobotAngle:
            RobotAngle = argument*2;
          break;
      //====================================
          case SetMotorRamp:
            MotRamp = argument;
          break;
      //====================================
          case CalibServoDrive:  
            // allows Servo Drive Motors to continue to pulse at center position
            CalibMotors = argument;
          break;
      //====================================
          case SetSlowDownSpeed:
            SlowDownSpeed = argument;
            if (SlowDownSpeed>100) SlowDownSpeed = 100;
          break;
      //====================================
          case SetBeaconTime:
            BeaconTime = 10*argument;
          break;
      //====================================
          case MuteBeaconDet:
            MuteBeacon = argument;
          break;
      //====================================
          case SetRROStimeout:
            RROStimeout = argument;
            //if (RROStimeout<15) RROStimeout=15;
          break;
      //====================================
          case SetTurretWidth:
            TurretWidth = argument;
          break;
      //====================================
          case SetBeaconDelay:
            bd1=argument*2;
          break;
      //====================================
          case SetSteerMult:
            SteerMult = argument;
            if(SteerMult>100) SteerMult=100;
            if(SteerMult<1) SteerMult=1;
          break;
      //====================================
          case SetSteerServoDir:
            if(argument==1)
              SteerServoDir = 1;
            else
              SteerServoDir = -1;
          break;
      //====================================
          case SetServoDir:
            ServoDir = argument;
            if(argument!=1)
              ServoDir = -1;
          break;
      //====================================
          case SetRobotDiameter:
            RobotDiameter = argument;
          break;
      //====================================
          case SetMoveToMax:
            MoveToMax=argument;
          break;
          //====================================
          case SetMoveToMin:
            MoveToMin=argument;
          break;
      //====================================
          case ReadBeaconAngles:
          sum=0;
          rd=0;
          gr=0;
          rdNum=0;
          grNum=0;
            //if(IsArmExpansion==3)
              {
              //read angles
              // move through entire range fast looking for beacons
              for(i=0;i<5;i++)  // ensure at start position
                {
                  LeftMotor(COAST);       // turn pulse on
                  delay_us(NAVservoMin);  // wait correct time
                  LeftMotor(BRAKE);       // turn pulse off
                  delay_ms(20);
                }
              for(k=NAVservoMin;k<=NAVservoMax;k+=6)// go through range
                {
//                sum=0;
                LeftMotor(COAST);
                delay_us(k);  
                LeftMotor(BRAKE); 
                delay_ms(15);
                if(WideOn() )// if wide detector found
                  {
//sum++;

                   // Determine what beacon this is and record it in bnum
                   // use bnum later to determine if/where to place answer
                   // assume Beacon is low

			       // Beacon detected, now see which one
			       // first wait till beacon signal stops
                   temp=k-3;  // average beginning of wide beacon
                   UseWide=1;
                   while(PINC&2); // wait for pulses
                   delay_ms(1);
			       while(!(PINC&2));  // wait for pause
			       // then count the time till it starts again
                   delay_us(bd1);
			       for (bnum=1;bnum<=15;bnum++)
			         {
				     delay_us(500-7);
				     if(!(PINC&2))  // check twice to be sure its over
				         break;
				     }
                   //bnum is now the current beacon number found
                   // proceed till narrow detector sees beacon
                   // or until wide is no longer seen                  
                   for(;k<NAVservoMax;k++) 
                     {
                     LeftMotor(COAST);
                     delay_us(k);
                     LeftMotor(BRAKE);
                     delay_ms(15);
                     if (NarrowOn()) // check begin of narrow beacon  
                       {
                       temp=k;
                       UseWide=0;  // assume we will use the narrow beam
                       break;        
                       }
                     if(WideOff())// check end of wide beacon
                        {
                        // narrow was not found
                        temp=(temp+k-1)/2; // temp set to center of wide
                        for(;k<NAVservoMax;k+=1)  // make sure past wide beacon
                          {
                          LeftMotor(COAST); 
                          delay_us(k);
                          LeftMotor(BRAKE);
                          delay_ms(15);
                          if(WideOff())
                            break;
                          }
                        break;
                        }
                     } 
                  // if using narrow, go to END of narrow beacon
                  if(!UseWide) 
                    {
                    for(;k<NAVservoMax;k++) 
                      {
                      LeftMotor(COAST);
                      delay_us(k);  
                      LeftMotor(BRAKE); 
                      delay_ms(15);
                      if(NarrowOff())// check end of narrow beacon  
                        {
                        temp=(temp+k-1)/2; // temp set to center of narrow
                        break;        
                        }
                      }
                     // then move to end of wide in order to continue properly
                    for(;k<NAVservoMax;k+=6)
                      { 
                      LeftMotor(COAST);
                      delay_us(k);
                      LeftMotor(BRAKE);
                      delay_ms(20);
                      if(WideOff())
                        {
                        k+=3; // move just a litte to be sure 
                        LeftMotor(COAST);
                        delay_us(k);  
                        LeftMotor(BRAKE); 
                        delay_ms(30);
                        break;
                        }
                      }
                    }
                    if(bnum==GrBeacon)
                      {
                      gr+=temp;
                      grNum++;
                      }
                    if(bnum==RdBeacon)
                      {
                      rd+=temp;
                      rdNum++;
                      }

                    }          
                  
                }

                if (grNum>0) 
                  gr/=grNum;
                if (rdNum>0)
                  rd/=rdNum;
                SensorBuffer[0]=gr>>8;
                SensorBuffer[1]=gr&255;
                SensorBuffer[2]=rd>>8;
                SensorBuffer[3]=rd&255;
                SensorBuffer[4]=grNum+rdNum;
              // move BACK to starting position
              for(k=NAVservoMax;k>=NAVservoMin;k-=15)
                {
                  LeftMotor(COAST); //PORTD|=2;     // turn pulse on
                  delay_us(k);  // wait correct time
                  LeftMotor(BRAKE); //PORTD&=~2;    // turn pulse off
                  delay_ms(15);
                }
              for(i=0;i<10;i++)  // ensure at start position (index overshoot
                {
                  LeftMotor(COAST);       // turn pulse on
                  delay_us(NAVservoMin);  // wait correct time
                  LeftMotor(BRAKE);       // turn pulse off
                  delay_ms(15);
                }

              }
            return;
          break;
      //====================================
          case SetNAVbeacons:
          GrBeacon = argument>>4;
          RdBeacon = argument&15;
          break;
      //====================================
          case SetNAVservoMinHigh:
            NAVservoMin += (argument<<8);
          break;
      //====================================
          case SetNAVservoMinLow:
            NAVservoMin = argument;
          break;
      //====================================
          case SetNAVservoMaxHigh:
            NAVservoMax +=(argument<<8);
          break;
      //====================================
          case SetNAVservoMaxLow:
            NAVservoMax = argument;
          break;
      //====================================
          case SetSlowDown2:
            SlowDown2 = argument;
          break;
      //====================================
          case SetPCBcalibrate:
            PCBcalibrate = argument;
          break;
      //====================================
          case RROSversion:
            delay_ms(2000);
            for(i=1;i<=2;i++)
              {            
              tone(400,300);
              delay_ms(1000);
              }
            for(i=1;i<=1;i++)
              {
              tone(400,150);
              delay_ms(500);
              }
             delay_ms(1000);
          break;
      //====================================
          case Drive:
            DriveDir = argument>>6;
            DrivePer = (argument&63)*2;
            switch (DriveDir)
              {
              case 0:
                motors(ServoDir*speed,ServoDir*(DrivePer*speed)/100);
              break;
              case 1:
                motors(ServoDir*(DrivePer*speed)/100,ServoDir*speed);
              break;
              case 2:
                motors(-ServoDir*speed,-ServoDir*(DrivePer*speed)/100);
              break;
              case 3:
                motors(-ServoDir*(DrivePer*speed)/100,-ServoDir*speed);
              break;
              }
          break;
      //====================================
          case ReadRangers:
            ReadAnalogSensors();
            for(i=0;i<5;i++)
              SensorBuffer[i]=MyAnalog[i];
            return;
          break;
      //====================================
          case SetCompassType:
            CompassType = (argument&24)>>3; //56
            if(CompassType==1) 
              {
              InitI2C();
              Read_Compass();
              Read_Compass();
              Read_Compass();
              }
            if(CompassType==2)  
              {
              Init_Compass2();
              }
          break;
       //====================================
		  case ForwardWithFeel:
            BackDirection = 0;
            Ramping=1;
            if (argument==0)
               {
			   motors(0,0);
               RunMotors();
               return;
               }
            i=0;
            CCleft=CCright=0;
            LastLeftCount  = PINB & 0b00000001;
            LastRightCount = PINB & 0b00000010;
            LeftCount=0;
            RightCount=0;
            if(CountersEnabled)
                 {                                
                 motors(speed,speed);
                 t=0;
                 while((LeftCount/CountDiv)<((ClicksPerDiam*argument)/40))
                   {
                   if((LeftCount/CountDiv)>(  ((ClicksPerDiam*argument)/40) - (ClicksPerDiam/2)))
                      {motors(SlowDownSpeed,SlowDownSpeed);}
                   if(SlowDown2 && ((LeftCount/CountDiv)>(((ClicksPerDiam*argument)/40)-(ClicksPerDiam/4))))
                      {motors(SlowDown2,SlowDown2);}
                   RunMotors();
                   t++;
                   if (t>1500)
                     break;
                   i++;
                   if(i==10)
                     {
                     i=0;
                     ReadSensors();
                     if(SensorBuffer[1]&14)
                       { // object detected
                       motors(0,0);
                       if(SlowDown2)
                         motors(SlowDown2,SlowDown2);
                       else
                         motors(SlowDownSpeed,SlowDownSpeed);
                       for(k=0;k<60;k++)
                         RunMotors();
                       break;
                       }
                     }
                   }
                 motors(0,0);
                 RunMotors();
                 SensorBuffer[0]=(((LeftCount*40)/CountDiv)/ClicksPerDiam);
                 for(k=1;k<5;k++)
                   SensorBuffer[k]=0;
                 return;
			   }
   	 		 return;	
		  break;
       //====================================
          case SetBeaconSpeed:
            BeaconSpeed=argument;
          break;
 
/* 
      //====================================
          case SetArmIndex:
            Index = argument;
            return;
          break;
      //====================================
          case WriteArmData:
            if (!CWarm) InitSpeeds();
              if((Index>=0)&&(Index<=7))
                {
                SendServoData(Index,argument);
                Index++;
                }
              if((Index>=8)&&(Index<=15))
                {
                CWSerialOut(128);
                CWSerialOut(1);
                CWSerialOut(1); // set speed
                CWSerialOut(Index&7);
                CWSerialOut(argument); // default speed
                CWarm = 1;
                Index++;
                }
              if((Index>=16)&&(Index<=23))
                {
                OffSet[Index&7]=argument;
                Index++;
                }
              if((Index>=128)&&(Index<=(128+89)))
                {
                Array[Index&127]=argument;
                Index++;
                }
            return;
          break;
      //====================================
          case SetHand:
            if (!CWarm) InitSpeeds();
            SendServoData(0,argument);
            Index=1;
            return;
          break;
      //====================================
          case MoveArm:
            if (!CWarm) InitSpeeds();
            if ((Index>=0) && (Index<=89))
              {
              SendServoData(Array[argument*3],1);
              SendServoData(Array[argument*3+1],2);
              SendServoData(Array[argument*3+2],3);
              Index+=3;
              }
            return;
          break;
      //====================================
*/

       };
   if(!IsArmExpansion)
     ReadSensors();
}

void SendServoData(char n, char d)
  {
  CWSerialOut(128);
  CWSerialOut(1);
  CWSerialOut(3);
  CWSerialOut(n);
  d=d+OffSet[n];
  CWSerialOut(d>>7);
  CWSerialOut(d&127);
  }

void InitSpeeds(void)
  {
  char n;
  DDRD |= 4;
  for (n=0;n<=7;n++)
    {
    CWSerialOut(128);
    CWSerialOut(1);
    CWSerialOut(1); // set speed
    CWSerialOut(n);
    CWSerialOut(60); // default speed
    CWarm = 1;
    }
  }

char SeeWide(void)
  {
  for(int j=1;j<=3;j++)
    if(!(PINC&2))
      return 1;
  return 0;
  }

char SeeNarrow(void)
  {
  for(int j=1;j<=3;j++)
    if(!(PINC&4))
      return 1;
  return 0;
  }

char WideOn(void)
  {
  if(!(PINC&2) && !(PINC&2) && !(PINC&2))
    return 1;
  delay_us(bd2);
  if(!(PINC&2) && !(PINC&2) && !(PINC&2))
    return 1;
  return 0;
  }

char WideOff(void)
  {
  return (!WideOn() && !WideOn() && !WideOn());
  }

char NarrowOn(void)
  {
  if(!(PINC&4) && !(PINC&4) && !(PINC&4))
    return 1;
  delay_us(bd2);
  if(!(PINC&4) && !(PINC&4) && !(PINC&4))
    return 1;
  return 0;
  }

char NarrowOff(void)
  {
  return (!NarrowOn() && !NarrowOn() && !NarrowOn());
  }

char BeaconOn(void)
  {
  if(!(PIND&16))
    return 1;
  else
    {
    delay_us(bd2);
    return (!(PIND&16));
    }
  return 0;  
  }

void Initialization(void)
  {
			// standard configuration variables
			SpeedLeft =             0;
            SpeedRight =            0;
            LeftOffset =            0;
            RightOffset =           0;
            CurLeft =               0;
            CurRight =              0;
            LastLeftCount =         PINB&1;
            LastRightCount =        PINB&2;
            LeftCount =             0;
            RightCount =            0;
            CCleft=CCright=         0;


            MotorForward =          1;
            MotorBackward =         2;
            CurDirLeft =            MotorForward;
            CurDirRight =           MotorForward;

            CCdivisor =             3;     
            TurnStyle =             50;
            CalibMotors =           0;  // for servo motors only  
// defaults
            ClicksPerDiam =         150;
            ClicksPer90 =           100;
            RotTime =               35;
            MoveTime =              20;
            MotRamp =               2; // default ramp;
            speed =                 25;
            SlowDownSpeed =         20;
            SlowDown2 =             15;
            RROStimeout =           15;
            BeaconSpeed =           30;
            if(MotorType==0)
              {
              RightMotor(BRAKE);
              LeftMotor(BRAKE);
              }

// alternate setup for servo motors           
            if(MotorType==1) 
              {
              RightMotor(BRAKE);
              LeftMotor(BRAKE);
    		  LeftOffset =            128;
    		  RightOffset =           128;
    		  //DeltaSpeed =          15;
              MotRamp =             3;
    		  CCleft=CCright =      0;
    		  MotorBackward =       -1;
    		  MotorForward =         1;
              ClicksPerDiam =       73;
              ClicksPer90 =         45;
              RotTime =              12;
              MoveTime =              9;
              CurDirLeft =          MotorForward;
              CurDirRight =         MotorForward;
              speed = 95;
              SlowDownSpeed = 85;
              SlowDown2 = 65;
              TurnStyle=50;
              CCdivisor = 8;
              CalibMotors = 1;
              BeaconSpeed = 50;
              }

// alternative setup for simple serial motor controller (Robo Claw or equiv)
           if(MotorType==2)
             {
    		  //LeftOffset =      127;
    		  //RightOffset =     127;

              MotRamp =             1;
    		  CCleft=CCright =      0;
    		  MotorBackward =       -1;
    		  MotorForward =         1;
              ClicksPerDiam =       30;
              ClicksPer90 =          9;
              CurDirLeft =          MotorForward;
              CurDirRight =         MotorForward;
              RightMotor(COAST);    // set serial I/O lines High
              LeftMotor(COAST);
              SerialMotorOut(0);
             }

// alternate setup for steerable robot           
            if(MotorType==3) 
              {
              RightMotor(BRAKE);
              LeftMotor(BRAKE);
    		  LeftOffset =            0;
    		  RightOffset =           0;
    		  //DeltaSpeed =          15;
              MotRamp =             1;
    		  CCleft=CCright =      0;
    		  MotorBackward =       -1;
    		  MotorForward =         1;
              ClicksPerDiam =       30;
              ClicksPer90 =          9;
              CurDirLeft =          MotorForward;
              CurDirRight =         MotorForward;
              }
       
   }


//------------------------------------------------------------------
// reads six analog signals no matter what types of sensors are used
// stores values in MyAnalog[0-5]
//------------------------------------------------------------------
void ReadAnalogSensors(void)
  {
      char i,j,k;
      int sum;
      int p[6]={0,1,2,3,6,7};
      switch(AnalogType)
      {
      case 0:  // IR short
      case 1:  // IR long
        set_analog_mode(MODE_8_BIT);
        for(i=0;i<NumAnalog;i++)
          {
          ReadSamples(p[i]);
          if(AnalogType==0)
            MyAnalog[i]=ConvertShortIR(Samples[5]);
          else
            MyAnalog[i]=ConvertLongIR(Samples[5]);
          }
      break;

      case 2:  // Sonar  
        set_analog_mode(MODE_10_BIT);
        for(i=0;i<NumAnalog;i++)
          {
          ReadSamples(p[i]); 
          MyAnalog[i]=(Samples[5]);         
          }
      break;

      case 3:  // Ping
//      if(PCBcalibrate)
// always read PINGs in two groups
        {
        // to prevent reflections with adjacent sensors, read in two cycles
        // prepare to read
        for(i=0;i<NumAnalog;i++)
          MyAnalog[i]=0; // zero all values	
        // read sensors 1,4,16        
        // pulse for 4 microseconds
		PORTC |= 0b00000101 ;  // pulse all lines high
        PORTD |= 0b10000000;
        if(NumAnalog==6)
          PORTD |= 4;
		delay_us(5);
		PORTC &= ~0b00000101;  // return low
        PORTD &= ~0b10000000;
        delay_us(850);  // required wait time
		DDRC &=  ~0b00000101;  // make pins input to monitor return pulse
        DDRD &=  ~0b10000000;
		for(j=0;j<106;j++)  // count while return pulse is high to get reading
		  {
          if(CountersEnabled)
            {
            CountWheels();
            delay_us(67);
            }
          else
		    delay_us(70);
          for(i=0;i<3;i+=2)
		    if ((!(PINC & (1<<i)))&&(!MyAnalog[i])) // save count when pulse ends (returns to zero)
		      MyAnalog[i]=j;      // at this point j is the count representing the pulse width
          if((!(PIND&128)) && (!MyAnalog[4]))
            MyAnalog[4]=j;       
		  }  

        // read sensors 2,8,and rear
        // pulse for 4 microseconds
		PORTC |= 0b00001010 ;  // pulse all lines high
        if(NumAnalog==6)
          PORTD |= 4;
		delay_us(5);
		PORTC &= ~0b00001010;  // return low
        if(NumAnalog==6)
          PORTD &= ~4;
        delay_us(850);  // required wait time
		DDRC &=  ~0b00001010;  // make pins input to monitor return pulse
        if(NumAnalog==6)
          DDRD &= ~4;
		for(j=0;j<106;j++)  // count while return pulse is high to get reading
		  {
          if(CountersEnabled)
            {
            CountWheels();
            delay_us(67);
            }
          else
		    delay_us(70);
          for(i=1;i<4;i+=2)
		    if ((!(PINC & (1<<i)))&&(!MyAnalog[i])) // save count when pulse ends (returns to zero)
		      MyAnalog[i]=j;      // at this point j is the count representing the pulse width
          if((!(PIND&4)) && (!MyAnalog[5]) && (NumAnalog==6) )
            MyAnalog[5]=j;         
		  }  
        }    
         
        if(PCBcalibrate)
          {
          if((MyAnalog[0]>5) & (MyAnalog[0]<100))MyAnalog[0] -= 2;
          if((MyAnalog[4]>5) & (MyAnalog[4]<100))MyAnalog[4] -= 2;
          }  
                           
		for(i=0;i<NumAnalog;i++)
          {
          if (MyAnalog[i]<3) 
            MyAnalog[i] = 150;
          if (MyAnalog[i]<4)
            MyAnalog[i] = 0;
          if (MyAnalog[i]>=4) 
            MyAnalog[i]-=4;
		  if (MyAnalog[i]>100)
            MyAnalog[i]=255;
          }
		delay_us(200);  // quiet time between readings
        // make all 6 pins outputs
        DDRC |= 0b00001111;	// make outputs again
        DDRD |= 0b10000000;	
        if(NumAnalog==6)
          DDRD |= 4;
//		PORTC &= ~0b00001111;  // ensure they are low
//        PORTD &= ~0b10000000;
//        if(NumAnalog==6)
//          PORTD &= ~4;
      break;

      case 4:  // Ping look alikes
        // make pulse pin an output
        DDRD |= 0b00000100;
        for(i=0;i<5;i++)
          MyAnalog[i]=0; // zero all values

        // pulse for 4 microseconds 
        PORTD |= 0b00000100; // pulse trigger for all
		delay_us(15);
        PORTD &= ~0b00000100;  // return low
        delay_us(850);  // required wait time
		DDRC &=  ~0b00001111;  // make pins input to monitor return pulse
        DDRD &=  ~0b10000000;
		for(j=0;j<102;j++)  // count while return pulse is high to get reading
		  {
          if(CountersEnabled)
            {
            CountWheels();
            delay_us(60);
            }
          else
		    delay_us(65);
          for(i=0;i<4;i++)
		    if ((!(PINC & (1<<i)))&&(!MyAnalog[i])) // save count when pulse ends (returns to zero)
		      MyAnalog[i]=j;      // at this point j is the count representing the pulse width
          if((!(PIND&128)) && (!MyAnalog[4]))
            MyAnalog[4]=j;        
		  }  


        if(PCBcalibrate)
          {
          if (MyAnalog[0] != 255) MyAnalog[0]+=1;
          if (MyAnalog[1] != 255) MyAnalog[1]+=3;
          if (MyAnalog[2] != 255) MyAnalog[2]+=4;
          if (MyAnalog[3] != 255) MyAnalog[3]+=3;
          if (MyAnalog[4] != 255) MyAnalog[4]+=1;
          }                      
		for(i=0;i<5;i++)
		  if((MyAnalog[i]>90) || (MyAnalog[i]<6) )
            MyAnalog[i]=255;
		delay_us(200);  // quiet time between readings
      break;
      }
  }

void ReadSensors(void)
  {
  char i,j;
  Line=0;
  Bump=0;
  IR=0;
  char t[5]={0,0,0,0,0};
  if (!SensorsEnabled) return;
  // data stored in global variables Bump, IR, Line
  // first read line sensors
  if(!ArmAvail)
    {
    DDRB &= ~(0x34); // make inputs
    PORTB |= 0x34;  // enable pullups
    delay_ms(2);
    Line = (((PINB>>2)&1) | ((PINB>>3)&6)); // 3 bits
    }
  else
    {
    ExpansionSerialOut(ReadArmSensors);
    ExpansionSerialOut(ArmAvail);
    for(i=0;i<5;i++)
      t[i]=ExpansionSerialIn();
    Line=t[2]|((PINB>>2)&1);
    }
  set_analog_mode(MODE_8_BIT);
  // now read perimeter sensors which may be digital or analog
  if(SensorMode > 0)
    {   
    // analog sensors
//    IR=0;
//    Bump=0;
    ReadAnalogSensors();
    // convert to bumpers
    if(MyAnalog[0]<LowLevelSense)
      Bump |=2;
    if(MyAnalog[4]<LowLevelSense)
      Bump |=8;
    for(i=1;i<=3;i++)
      if(MyAnalog[i]<LowLevelSense)
        Bump|=4;
    if(AnalogType==4)
      {
      if(analog_read(6)<100) 
        Bump |= 1;
      }
    else
      {
      if(NumAnalog==6)
        {
        if(MyAnalog[5]<LowLevelSense)
          Bump |= 1;
        }
      else
        {
        if(!(PIND&4))
          Bump |= 1;
        }
      }
    // convert to IR
    for(i=0,j=1;i<5;i++,j=j<<1)
      if(MyAnalog[i]<HighLevelSense)
        IR |= j;
    }
  else
    {
    // digital sensors (no bumpers)
    // MAKE SURE PORT C IS A DIGITAL INPUT PORT
    Bump=0;
    DDRC &= ~15;
    IR = (PINC&15)^15;
    if(AnalogType!=3) 
      {
      // analog ranger
      DDRD &= ~128;
      IR |= (((PIND&128)>>3)^16); 
      }
    else              
      {
      // Ping ranger for sensors
      if(analog_read(6)<100)
        IR |= 16;
      }
    }


  if(ExpSensorsAvail)  // or additional sensor data with current data from standard sensors
    {
    ExpansionSerialOut(ReadExpSensors);
    ExpansionSerialOut(0);
    for(i=0;i<5;i++)
      t[i]=ExpansionSerialIn();
    Bump|=t[0];
    IR  |=t[1];
    Line|=t[2];   
    }

  Line = Line^SenseInvMask;
  SensorBuffer[0]=Bump;
  SensorBuffer[1]=IR;
  SensorBuffer[2]=Line; 
  }

// -------------------------------------
// reads five samples from pin p
// assumes resolution has been selected
// stores in Samples[0-2]
// -------------------------------------
void ReadSamples(char p)
  {
  int temp;
  char i,j;
  if(AnalogType<2)
    set_analog_mode(MODE_8_BIT);
  else
    set_analog_mode(MODE_10_BIT);
  for(i=0;i<11;i++)
    {
    Samples[i]=analog_read(p);
    if((Samples[i]<10) && (AnalogType<2)) 
      Samples[i]=10;
    if(AnalogType==2)
      {
      Samples[i]-=11;
      if (Samples[i]<0) Samples[i]=0;
      }
    if(Samples[i]>255)  // for 10 bit reads
      Samples[i]=255;   
    }
  // sort, middle entry should be good (discard extremes)
  for(j=0;j<10;j++)
    for(i=0;i<10-j;i++)
      if(Samples[i]>Samples[i+1])
        {
        temp=Samples[i+1];
        Samples[i+1]=Samples[i];
        Samples[i]=temp;
        }
  }

//-------------------------------------
//    Special read for a Ping Ranger
//-------------------------------------
char ReadPingRanger(void)
	   {
       char k;
	    // read PING on pin p and return result
	  	// make pin an output
		DDRD |= (128);
		// pulse for 4 microseconds
		PORTD |=  128;  // pulse high
		delay_us(5);
		PORTD &= ~(128);  // return low
        delay_us(850);  // required wait time 750
		DDRD &=  ~(128);  // make pin an input to monitor return pulse		
		for(k=0;k<102;k++)  // count while return pulse is high to get reading
		  {
		  delay_us(70);
		    if (!(PIND & 128)) // exit when pulse ends (returns to zero)
		      break;              // at this point j is the count representing the pulse width
		  }
		if (k>100)
		  k=255;
		delay_us(200);  // quiet time between readings
        return k;
	   }

char ConvertLongIR(char n)
  {
  char a;
  n = n+(n>>1);
  if(n>160)
    a=(10000/n)-48;
  else if(n>66)
    a=(4000/n)-12;
  else if(n>55)
    a=3000/n;
  else if(n>31)
    a=(5000/n)-38;
  else
    a=(7000/n)-112;
  if (a>140)
    a=255;
  return a;
  }

char ConvertShortIR(char n)
  {
  char a;
  n = n+(n>>1);
  if(n>130)
    a=(2800/n)-10;
  else
    a=1800/n;
  if(a>70) a=255;
  return a;
  }


void tone(long freq, long dur)
   {
   // assumes buzzer attached to PB5
   int i;

// set pin as output
   DDRD |= 16;
// set PD4 HIGH
   PORTD |= 16;
   // produced the desired freq and duration
   for (i=0;i<(dur*freq)/1000;i++)
     {
	 delay_us(500000/freq);
	 PORTD &= ~16; // set low
	 delay_us(500000/freq);    
     PORTD |= 16; // set high
	 }

   if(MuteBeacon)  // pot error
     PORTD &= ~16;
   else             
     DDRD &= ~16; // input
   }

void changeTone(int start, int finish, int steps, int dur)
  {
  int f,step; 
  step = (finish-start)/steps;
  if (finish>start)
    for(f=start;f<=finish;f+=step)
      tone(f,dur/steps);
  else
    for(f=start;f>=finish;f+=step)
      tone(f,dur/steps);
  }

void PlayNote(unsigned int Freq,int Dur)
  {
   // assumes buzzer attached to PB5
   long int i;
   DDRD |= 16;
   if (Dur==7) Dur=8;
   // produced the desired freq and duration
   if(Freq)
     {
     // set pin as output
     DDRD |= 16;
     // set PD4 HIGH
     PORTD |= 16;
     for (i=0;i<((Dur*100000)/Freq);i++)
       {
	   delay_us(Freq);
	   PORTD &= ~16; // set low
	   delay_us(Freq);    
       PORTD |= 16; // set high
	   }
     }
    else  // just delay proper amount... no tone
      for(i=0;i<(Dur*100000)/478;i++)
        delay_us(478*2);
   if(MuteBeacon)
     PORTD &= ~16;
   else             
     DDRD &= ~16; // input
  }


void motors(int left, int right)
  {
  char ReverseDirection = 0;
  if(left==0 && right==0)
    {
    CCleft=0;
    CCright=0;
    }
 if(MotorType==0)
  {
  // determine if motors are reversing directions
  if((left>0 && CurDirLeft==REVERSE) || (left<0 && CurDirLeft==ON))
    {
    ReverseDirection=1;
    SpeedLeft=0;
    }
  if((right>0 && CurDirRight==REVERSE) || (right<0 && CurDirRight==ON))
    {
    ReverseDirection=1;
    SpeedRight=0;
    }
  // if so ramp down to zero before continuing
  if(ReverseDirection)
    while((CurLeft!=SpeedLeft) && (CurRight!=SpeedRight))
      RunMotors();
  // now system will ramp Up to new speed with minimal jerk
  } 
 if(MotorType==5)  // try to make work for all other types and check BOTH motors for reversing
  {
  // determine if motors are reversing directions
  if((left>0 && CurDirLeft==MotorBackward) || (left<0 && CurDirLeft==MotorForward))
    {
    // ramp down to zero first
    SpeedLeft=0;
    while(CurLeft!=SpeedLeft)
      RunMotors();
    // now system will ramp Up to new speed with minimal jerk
    }   
  } 


  SpeedLeft=abs(left);
  if(MotorType!=3)
    SpeedRight=abs(right);

  if(MotorType==0)
    {
    if(left<0) 
      CurDirLeft = REVERSE;
    if(left>0)
      CurDirLeft = ON;
    if(right<0)
      CurDirRight = REVERSE;
    if(right>0)
      CurDirRight = ON;
    }
  if(MotorType>0 && MotorType<3)
    {
    if(left<0) 
      CurDirLeft = MotorBackward;
    if(left>0)
      CurDirLeft = MotorForward;
    if(right<0)
      CurDirRight = MotorBackward;
    if(right>0)
      CurDirRight = MotorForward;   
    }
  if(MotorType==3)  // reset parameters for steer
    {
    if(left<0) 
      CurDirLeft = MotorBackward;
    if(left>0)
      CurDirLeft = MotorForward;   
    }
  }

// ===================================================================
// *******************************************************************
// This is the main function, where the code starts.
// *******************************************************************
// ===================================================================

int main()
{
    char i;
    char InputBuffer[2]={0,0};
    char TimeOutCount = 0;
    set_analog_mode(MODE_8_BIT);
	serial_set_baud_rate(9600);
    serial_set_mode(SERIAL_AUTOMATIC);
DDRD |= 0b01101000;  // all pins output
DDRB |= 0b00001000;
RightMotor(BRAKE);
LeftMotor(BRAKE);
//PORTD &= ~0b01101000;  // all pins high impedance
//PORTB &= ~0b00001000;
    tone(200,500);
    InputBuffer[0]=0;
	InputBuffer[1]=0;
    serial_receive(InputBuffer,2);
    TimeOutCount=0;
    motors(0,0);
    while(1)
	  {
      if(serial_get_received_bytes()==2)
	    {
        TimeOutCount = 0;
        serial_receive_blocking(InputBuffer,2,2);
	    ProcessCommand(InputBuffer);
        if(IsArmExpansion)
          {
          for(i=0;i<5;i++)
            SerialMotorOut(SensorBuffer[i]);
          }
        else
          {
          if(!SlowSerial)
            {
		    serial_send_blocking(SensorBuffer,5);
            }
          else
            {
            for(i=0;i<5;i++)
              {
              serial_send_blocking(&SensorBuffer[i],1);
              delay_ms(2);
              }
            }
          if((AnalogType==2)  && (SensorMode>0)  && SensorsEnabled)
            {
            //Pulse Ultrasonic Trigger
            PORTD |= 128; // set high
            delay_us(25);
            PORTD &= ~128; // return low
            }
          }
		}
      else
        {
        if(IsArmExpansion)
          ServoMotors();
        else
          {
          TimeOutCount++;
          if(TimeOutCount== RROStimeout)  // shut down motors if no command in 25ms
            {
            motors(0,0);        
            TimeOutCount=0;   
            }
          RunMotors();// must pulse the motors ONCE and return
          }
        } 
      // trigger ultrasonics if they exist
      if( (SensorMode>0)&&(AnalogType==2) )
        {
        PORTD |= 128; //pulse high
        delay_us(100);
        PORTD &= ~128; // return low
        } 
	  }
    
}




void MoveToAngle (int dest)
  {
  int i,j,k,s,d,c;
  if (CompassType<1)
    return;
  if (CompassType==1)
    CompassTime=15;
  c = Read_Compass();
  if (c==dest)
    return;
  if(c==0)
    {
    s=(MoveToMax+MoveToMin)/2;
    motors(s,-s);
    for (i=1;i<15;i++)
      RunMotors();
    }
  for (i=30;i>=1;i--)
    {
    for (k=1;k<=10;k++)
      {
      c=Read_Compass();
      d = Compare(dest, c);
      if(abs(d)<=i) break;
      s=MoveToMax;
      if(abs(d)<100) s=(MoveToMax+MoveToMin)/2;
      if(abs(d)<30) s=MoveToMin;
      s=s*ServoDir;
      if(d>0)
        motors(s,-s);
      else
        motors(-s,s);
      for(j=0;j<2+(abs(d)/8);j++)
        RunMotors();       
      }
    motors(0,0);
    RunMotors();
    }
  motors(0,0);
  RunMotors();
  CompassTime=0;
  }

  
int Compare(int dest, int start)
  {
  int a;
  a=dest-start;
  if (abs(a)>180)
    {
    if(dest>180)
      a = -(360-a);
    else
      a = 360+a;
    }
  return a;
  }




//-------------------------------------------------------------------------------------------------------------------
//                                         The Drive Motor Module
// This module has been designed to serve the needs of most hobbyists.  It can handle DC motors connected to the standard
// on-board motor controller in our RROS hardware board.  It also supports servomotors and servomotor-compatible motor controllers.                                             
//---------------------------------------------------------------------------------------------------------------------
/* Internal Motor Pins
     Left   PD5,PD6
	 Right  PD3,PB3
   PD5/PD3    PD6/PB3                     M1A/M2A       M1B/M2B
      0          0          Coast (OFF)         Hi Imped
	  1          1          Brake            0             0
	  0          1          Forward          0             1
	  1          0          Reverse          1             0   
*/  
// the following three routines are for the internal motor driver
void InitMotorDriver(void)
  {
  DDRD |= 0b01101000;  // all pins output
  DDRB |= 0b00001000;
  PORTD &= ~0b01101000;  // all pins high impedance
  PORTB &= ~0b00001000;
  }   

void LeftMotor(char mode)  // ON, COAST, REVERSE, BRAKE
  {
  switch (mode)
    {
	case ON:
	  PORTD &=   ~0b01100000;
	  PORTD |=    0b01000000;
	break;
	case COAST:
	  PORTD &=   ~0b01100000;
	break;
	case REVERSE:
	  PORTD &=   ~0b01100000;
	  PORTD |=    0b00100000;
	break;
	case BRAKE:
	  PORTD |=    0b01100000;
	break;
	}
  }

void RightMotor(char mode) // ON, COAST, REVERSE, BRAKE
  {
    switch(mode)
	{
  	case ON:
	  PORTD &=    ~0b00001000;
	  PORTB &=    ~0b00001000;
      PORTD |=     0b00001000;
	break;
	case COAST:
	  PORTD &=    ~0b00001000;
	  PORTB &=    ~0b00001000;
	break;
	case REVERSE:
	  PORTD &=    ~0b00001000;
	  PORTB &=    ~0b00001000;
	  PORTB |=     0b00001000;
	break;
	case BRAKE:
	  PORTD |=     0b00001000;
	  PORTB |=     0b00001000;
	break;
	}
  }




// assumes MotorConfiguration is set
void RunMotors (void)
  {
  int m1,LM,RM;
  char motor,lm,rm,AllStop;
  if(!MotorsEnabled)  return;
  if(!MotRamp)
    {
    CurLeft=SpeedLeft;
    CurRight=SpeedRight;
    }
  if (MotorType == 0)  // standard on-board DC motor controller
    {
    AllStop = BRAKE;
    if (CountersEnabled)
      AllStop = COAST;
    //if ((CurRight==0) && (CurLeft==0))

// take out 0&&
    if((SpeedLeft==0)&&(SpeedRight==0)&&((CurRight+CurLeft)==0)) //&&(CurDirRight==CurDirLeft))
      { 

      LeftMotor(BRAKE);
      RightMotor(BRAKE);
      //delay_ms(300); // give motors time to stop
      }
    else
      {
	  // turn both motors on if appropriate 
      if (CurRight)
        RightMotor(CurDirRight);
      if (CurLeft)
	    LeftMotor(CurDirLeft);
      }      
    CountWheels();    
    // delay based on speed, then turn motors off to get duty cycle        
    for(m1=1;m1<(101);m1+=2)
      {	
      if (CurDirLeft==1)
        LM = (CurLeft- ((CurLeft *RedForLeft )/100)-CCleft );
      else
        LM = (CurLeft- ((CurLeft *RedBackLeft)/100)-CCleft );
      if (CurDirRight==1)
        RM = (CurRight-((CurRight*RedForRight)/100)-CCright);
      else
        RM = (CurRight-((CurRight*RedBackRight)/100) - CCright);
      if(LM<0) LM=0;
      if(RM<0) RM=0;
      if (m1>LM+CompassTime)
          LeftMotor(AllStop);
      if (m1>RM+CompassTime)
          RightMotor(AllStop); 
      delay_us(100);
      if(!(m1%5))
        CountWheels();
	  } 
    // ensure off even if combined speeds > 100
    RightMotor(AllStop);
    LeftMotor(AllStop);
    }         
  if(MotorType==1) 
    {      
	// Assumes Continuous Rotation Servos are used for Drive motors
    // Note: Many motor controllers have a servo input mode     
    // assumes there are 100 speeds (CurLeft and CurRight

    if(CurLeft)  // more than 1500 is forward 
      {
      if(CurDirLeft>0)
        PulseTimeLeft=1400-80+LeftStopOffset+((ServoDir*SerMotSpeedMult*(CurLeft-CCleft-((ServoDir*CurLeft*RedForLeft)/100)))/25);
      else
        PulseTimeLeft=1400-80+LeftStopOffset-((ServoDir*SerMotSpeedMult*(CurLeft-CCleft-((ServoDir*CurLeft*RedBackLeft)/100)))/25);
      }
    else
      PulseTimeLeft  = 1400-80+LeftStopOffset;
    
    if(CurRight)  // less than 1500 is reverse
      {
      if(CurDirRight>0)
        PulseTimeRight=1400-75-RightStopOffset+256-((ServoDir*SerMotSpeedMult*(CurRight-CCright-((ServoDir*CurRight*RedForRight)/100)))/25);
      else
        PulseTimeRight=1400-75-RightStopOffset+256+((ServoDir*SerMotSpeedMult*(CurRight-CCright-((ServoDir*CurRight*RedBackRight)/100)))/25);
      }
    else
      PulseTimeRight = 1400-75-RightStopOffset+256;


    if((CurLeft>0) || CalibMotors) // pulse or not, when "stopped"
      {
	  LeftMotor(COAST);  
      delay_us(PulseTimeLeft);
      LeftMotor(BRAKE);
      //if(PulseTimeLeft>100) CountWheels();  //********************************
      }


    if(CurRight>0 || CalibMotors)
      {
	  RightMotor(COAST);
      delay_us(PulseTimeRight);
      RightMotor(BRAKE);
      //if(PulseTimeRight>100) CountWheels();  //********************************
      }
    if(CompassTime!=0)  // use the delay of reading compass when doing a MOVEtoANGLE  *******************changed*******************
      {
      delay_us(1000);
      CountWheels();
      }
	// delay to ensure 50 hz pulse rate for servomotors
    if(CompassTime==0)
      for(m1=0;m1<10;m1++)   //  ***************************was 14
	    {
	    delay_ms(1);	       
        CountWheels(); 
	    }
    }
  if(MotorType==2) // roboclaw mode
    {
    for(m1=0;m1<15;m1++) // add delay to make serial respond similar to other modes
      {
      CountWheels();     // but count wheel pulses during the delay
      delay_ms(1);
      }
    // Simple serial interface with RoboClaw or equiv.
    // Outputs one command based on current speeds and corrections, then returns
    // char 0 shuts down both motors
    //  LEFT MOTOR    1-full reverse, 64-stop,  127-full forward
    //  RIGHT MOTOR 128-full reverse, 192-stop, 255-full forward  (128 more than LEFT motor)
    motor = 192;
    if(CurLeft)
      {
      if(CurDirLeft>0)
        {
        lm=((CurLeft-CCleft-((CurLeft*RedForLeft)/100))*2)/3;
        if(lm>63) lm=63;
        motor+=lm;
        }
      else
        {
        lm=((CurLeft-CCleft-((CurLeft*RedBackLeft)/100))*2)/3;
        if(lm>63) lm=63;
        motor-=lm;
        }
      }
    CountWheels();
    SerialMotorOut(motor);  
    motor = 64;
    if(CurRight)
      {      
      if(CurDirRight<0)
        {
        rm=((CurRight-CCright-((CurRight*RedForRight)/100))*2)/3;
        if(rm>63) rm=63;
        motor+=rm;
        }
      else
        {
        rm=((CurRight-CCright-((CurRight*RedBackRight)/100))*2)/3;
        if(rm>63) rm=63;
        motor-=rm;
        }
      }
    CountWheels();
    SerialMotorOut(motor);
    }
  if(MotorType==3)
    {
    // steerable robot, servo controlled steering, servo drive
    if(CurLeft)  // more than 1500 is forward 
      {
      if(CurDirLeft>0)
        PulseTimeLeft=1424+LeftStopOffset-128+(ServoDir*SerMotSpeedMult*CurLeft)/25;
      else
        PulseTimeLeft=1424+LeftStopOffset-128-(ServoDir*SerMotSpeedMult*CurLeft)/25;
      }
    else
      PulseTimeLeft  = 1424+(LeftStopOffset-128);
    if(CurRight)  // (Steering servomotor) less than 1500 is reverse (left)
      {
      if(CurDirRight>0)
        PulseTimeRight=1427-(RightStopOffset-128)-(SteerServoDir*SteerMult*CurRight)/12;
      else
        PulseTimeRight=1427-(RightStopOffset-128)+(SteerServoDir*SteerMult*CurRight)/12;
      }
    else
      PulseTimeRight = 1427-(RightStopOffset-128);
    // pulse Drive Motor
	LeftMotor(COAST);  
    delay_us(PulseTimeLeft);
    LeftMotor(BRAKE);
    if(PulseTimeLeft>100) CountWheels();
    // Pulse Steering Motor
	RightMotor(COAST);
    delay_us(PulseTimeRight);
    RightMotor(BRAKE);
    if(PulseTimeRight>100) CountWheels();
    delay_us(1000); //2000-PulseTimeLeft-PulseTimeRight);
    CountWheels();
	// delay to ensure 50 hz pulse rate for servomotors
    for(m1=0;m1<8;m1++)
	    {
	    delay_ms(1);	       
        CountWheels(); 
	    }
    }
    
  if(MotorType==4)
    {
    // Serial interface for 2 RoboClaw's and 4 motors with meccanum wheels
    }

    // change speeds slowly for all motor types
    if (CurLeft < SpeedLeft)  // slowly ramp up to speed
          {
          CurLeft += MotRamp; 
          if (CurLeft > SpeedLeft)
            CurLeft = SpeedLeft; 
          }
    if (CurRight < SpeedRight)
          {
          CurRight += MotRamp;
          if (CurRight > SpeedRight)
            CurRight = SpeedRight;
          }
    if (CurLeft>SpeedLeft) // more quickly ramp down to speed
          {
          CurLeft -= MotRamp;
          if (CurLeft < SpeedLeft)
            CurLeft = SpeedLeft;
          }
    if (CurRight>SpeedRight)
          {
          CurRight -= MotRamp;
          if (CurRight < SpeedRight)
            CurRight = SpeedRight; 
          } 
  }   
  
  
void SerialMotorOut(char d)
  {
  char i;
  char x=100;
  // outputs a byte on the RIGHT MOTOR pin (relative to ground) at 9600 baud (104us per bit)
  RightMotor(BRAKE);
  delay_us(x);
  for(i=0;i<8;i++)
    {
    if(d&1)
      RightMotor(COAST); // send a one
    else
      RightMotor(BRAKE); // send a zero
    d=d>>1;
    delay_us(x);
    }
  RightMotor(COAST);
  delay_us(20*x);// 10 stop bits (time for Host to recover
  }

void ExpansionSerialOut(char d)  // output one byte on PB5 at 9600 baud (104us per bit)
  {
  char i;
  PORTB &= ~(1<<5); // start bit
  delay_us(ExpTime);
  for(i=0;i<8;i++)
    {
    if(d&1)
      PORTB |= (1<<5); // send a one
    else
      PORTB &= ~(1<<5);; // send a zero
    d=d>>1;
    delay_us(ExpTime);
    }
  PORTB |= (1<<5);  // bring line high again
  delay_us(2*ExpTime);// 2 stop bits  (time for host to recover - hardware serial port)
  }  

//new
void CWSerialOut(char d)  // output one byte on PB5 at 9600 baud (104us per bit)
  {
  char i;
  PORTD &= ~(1<<2); // start bit
  delay_us(ExpTime);
  for(i=0;i<8;i++)
    {
    if(d&1)
      PORTD |= (1<<2); // send a one
    else
      PORTD &= ~(1<<2);; // send a zero
    d=d>>1;
    delay_us(ExpTime);
    }
  PORTD |= (1<<2);  // bring line high again
  delay_us(2*ExpTime);// 2 stop bits  (time for host to recover - hardware serial port)
  } 



char ExpansionSerialIn(void)  // input one byte on PB4 at 9600 baud
  {
  char i;
  char d=0;
  char Exp=105;
//  while(!(PINB&(1<<4)));  // wait till line is high
  while(PINB&(1<<4));     // wait till line goes low
  delay_us(Exp>>1);          // wait half bit time, now in the middle of start bit
  for(i=0;i<8;i++)         // get 8 bits
    {
    delay_us(Exp);           // wait a full bit time (center of next bit position)
    d=d>>1;
    d |= ((PINB<<3)&128);  // insert new bit as the MSB of d
    }
  delay_us(Exp);             // delay till middle of stop bit
  return d;
  }

/*
int MYsin(int a)
  {
  if(a<91)
    return +Trig[a];
  if(a<181)
    return +Trig[180-a];
  if(a<271)
    return -Trig[a-180]; 
  else
    return -Trig[360-a];
  }

int MYcos(int a)
  {
  if(a<91)
    return +Trig[90-a];
  if(a<181)
    return -Trig[90-(180-a)];
  if(a<271)
    return -Trig[90-(a-180)]; 
  else
    return +Trig[90-(360-a)];
  }

*/
/*
---------------------------------------------------------------------------------------------------------------------
                                          Wheel Counter Module
This module monitors an incremental (NOT quadrature) counter on each wheel and automatically adjusts wheel speeds
by modifying motor variables, based on current conditions.  This module has to be called periodially.                                         
---------------------------------------------------------------------------------------------------------------------
*/
void CountWheels(void)
  {
  int left,right;
  if (!CountersEnabled)
    {
    CCleft=0;
    CCright=0;
    return;
    }
  else
    {
    //if( (SpeedLeft==0) | (SpeedRight==0) | (SpeedLeft!=SpeedRight)  )
    if( ((CurLeft+CurRight)==0) || (SpeedLeft!=SpeedRight)  )
	  {
        // automatically zero wheel counters and corrections
        LeftCount  = 0;
        RightCount = 0;    
        CCleft=0; 
        CCright=0;
       // prepare for new count
        LastLeftCount  = PINB & 0b00000001;
        LastRightCount = PINB & 0b00000010;
	  }   
    else  
	  {
        // update counts and adjust CC (count correction) if COUNTS are not equal
        // check wheel counts
        left = PINB&0b00000001;
        if (LastLeftCount != left)
		  { 
           LeftCount++;
           LastLeftCount = left;
          }
        right = PINB & 0b00000010;
        if (LastRightCount != right )
		  {
           RightCount++;
           LastRightCount = right;
          }
        // make appropriate correction       
        //CCleft=0; // these numbers are subtracted from each wheel
        //CCright=0;
        if(MotorType==3) RightCount=LeftCount; // only one count on steerable robot
        if (LeftCount>RightCount)
          {
          CCleft=CurLeft/CCdivisor; 
          CCright=0;
          }
        if (RightCount>LeftCount)
          {
          CCright=CurRight/CCdivisor;
          CCleft=0;
          }
      }       
     }
   }



  
/*
-------------------------------------------------------------------------------------------------------
                                          The Servomotor Module
This module provides the signals to control five servomotors to control the joints of a robotic arm
as described in our RROS book.  Once started, this module controls the servos based on the data placed
in a series of global arrays.  Note: This module is normally NOT available on the main chip, but must
be implemented as an expansion processor.    
-------------------------------------------------------------------------------------------------------
*/




/*
void InitServoMotors(void)
  {
  char i;
  if(!(Expansion&32)) return;       
  // set all servo pins low
  for(i=0;i<5;i++)
    {
    DDRB  |= (1<<SerPin[i]);  // make all pins outputs
    PORTB &= ~(1<<SerPin[i]); // and set them to zero
    }
  }*/

void ServoMotors(void)  // pulses all motors once
  {
  int i,t,sum=0;
  if(!ServosEnabled) return;
  DDRB   |=  0b00110111; // set servo pins to output
  PORTB  &= ~0b00110111; // servo data to low for start
  for(i=0;i<5;i++)
    {
    // pulse pin based on current position
    t=800+(4*SerOffset[i])+(ServoMult[i]*CurPos[i])/12;
    sum+=t;
    PORTB |= (1<<SerPin[i]);  // set pin high
    delay_us(t);
    PORTB &= ~(1<<SerPin[i]); // set pin low
    // update current position by moving it toward the desired position
    if(CurPos[i]!=SerPos[i])
      {
      if(CurPos[i]<SerPos[i])
        {
        CurPos[i]+=SerInc[i];
        if(CurPos[i]>SerPos[i])
          CurPos[i]=SerPos[i];
        }
      else
        {
        CurPos[i]-=SerInc[i];
        if(CurPos[i]<SerPos[i])
          CurPos[i]=SerPos[i];
        }
      }
    }
  delay_us(20000-sum);
  }



/* ====================================================================
 *  The following routines are generic routines for reading I2C devices
 *  In this case, the only routines included are those specifically
 *  needed for reading and calibrating the HMC6352 and LSM303 compasses
 * ====================================================================
 */
typedef struct vector
{
	float x, y, z;
} vector;

  vector m_max = {340, 517, 416};
  vector m_min = {-642, -496, -462};

void read_data_raw(vector*, vector*);

void i2c_start() {  
	TWCR = (1 << TWINT) | (1 << TWSTA) | (1 << TWEN); // send start condition  
	while (!(TWCR & (1 << TWINT)));  
}  
  
void i2c_write_byte(char byte) { 

	TWDR = byte;              
	TWCR = (1 << TWINT) | (1 << TWEN); // start address transmission  
	while (!(TWCR & (1 << TWINT)));  
}  
  
int i2c_read_byte() { // this and next were char returns
 
	TWCR = (1 << TWINT) | (1 << TWEA) | (1 << TWEN); // start data reception, transmit ACK  
	while (!(TWCR & (1 << TWINT)));  
	return TWDR;  
}  

int i2c_read_last_byte() {  
	TWCR = (1 << TWINT) | (1 << TWEN); // start data reception
	while (!(TWCR & (1 << TWINT)));  
	return TWDR;  
}  
  
void i2c_stop() {  
    TWCR = (1 << TWINT) | (1 << TWSTO) | (1 << TWEN); // send stop condition 
}  






#define  SDA_PIN          2            //compass data pin
#define  SCL_PIN          4            //compas clockin  pin

#define  HMC6352_READ     0x43         //HMC6352 read address
#define  HMC6352_WRITE    0x42         //HMC6352 write address

#define  START_CALIB      0x43         //Start the calibration routine
#define  END_CALIB        0x45         //Finish the calibration routine
#define  GET_HEADING      0x41         //Read in the calculated heading


#define  GET_HEADING_DELAY  6          //6   ms
#define  START_CALIB_DELAY  10         //10  s
#define  END_CALIB_DELAY    1400       //14  ms

//------these may not be needed--------------------------
#define  ENTER_SLEEP      0x53         //Enter sleep mode
#define  WAKE_UP          0x57         //Exit sleep mode                                                                
#define  MODE_ADDRESS     0x4E         //RAM/EEPROM address for operational mode
#define  UPDATE           0x4F         //
#define  SAVE_MODE        0x4C         //Write the operational mode from RAM to EEPROM
#define  WRITE_EEPROM     0x77         //Read a byte from EEPROM
#define  READ_EEPROM      0x72         //Write a byte to EEPROM
#define  WRITE_RAM        0x47         //Read a byte from RAM
#define  READ_RAM         0x67         //Write a byte to RAM 


#define  READ_WRITE_DELAY   70         //70  s
#define  ENTER_SLEEP_DELAY  10         //10  s
#define  WAKE_UP_DELAY      80         //80  s
#define  UPDATE_DELAY       6000       //6   ms
#define  SAVE_MODE_DELAY    125        //125 s






//========================================================
// High Level Compass functions
//========================================================
//--------------------------------------------------------
int Read_Compass(void)
{ // returns compass Heading
  int i;
  int outputData[6];


  #define HMC5883_WriteAddress 0x1E //  i.e 0x3C >> 1
  int Heading=0;
  if (CompassType==0)
    return Heading; // NO COMPASS
  if (CompassType==1)
    {
    i2c_start();
    i2c_write_byte(HMC6352_WRITE);
    i2c_write_byte(GET_HEADING);
    i2c_stop(); 
    i2c_start();
    i2c_write_byte(HMC6352_READ);
    delay_ms(15); //GET_HEADING_DELAY);
    Heading = i2c_read_byte() << 8;
    Heading = Heading |i2c_read_last_byte();
    i2c_stop();
    Heading=Heading/10;
    }
  else
    {
    //Heading=Read_Compass2();
    i2c_start();
    i2c_write_byte(0x3c); // write address
    i2c_write_byte(2); // register 2
    i2c_write_byte(1); // read once
    i2c_stop();
    delay_ms(20);  //15

   for(i=0;i<6;i++)
        {
        i2c_start();
        i2c_write_byte(0x3c);
        i2c_write_byte(3+i);  // point to data registers
        i2c_stop();
        i2c_start();
        i2c_write_byte(0x3d); // read address?
        outputData[i]=i2c_read_byte();  //Store the data in outputData buffer
        }

    xCur=outputData[0] << 8 | outputData[1]; //Combine MSB and LSB of X Data output register
//    zCur=outputData[2] << 8 | outputData[3]; //Combine MSB and LSB of Z Data output register
    yCur=outputData[4] << 8 | outputData[5]; //Combine MSB and LSB of Y Data output register
 
    xCur-=xOffset;
    yCur-=yOffset;
    Heading= atan2((double)yCur,(double)xCur) * (180 / 3.14159265); // angle in degrees
    //Heading= atan2((double)xCur,(double)zCur) * (180 / 3.14159265); // angle in degrees
    if (Heading<0) Heading+=360;

    }
  Heading+=RobotAngle;
  if (Heading>359)
    Heading -=360;
  return Heading;
}


void Init_Compass2(void)        //*************************************************NEW COMPASS ********************************
  {
    InitI2C();
    i2c_start();      // gain
    i2c_write_byte(0x3c);
    i2c_write_byte(1);
    i2c_write_byte(0x40);
    i2c_stop();   
    i2c_start();      // speed and # of samples
    i2c_write_byte(0x3c);
    i2c_write_byte(0);
    i2c_write_byte(0x78);
    i2c_stop();  

  }



//==============================================================================
//--------------------------------------------------------
void Start_Calibration(void)
{
  //void 
  i2c_start();
  i2c_write_byte(HMC6352_WRITE);
  i2c_write_byte(START_CALIB);
  i2c_stop();
  delay_us(START_CALIB_DELAY);
}
//--------------------------------------------------------
void Finish_Calibration(void)
{
  //void 
  i2c_start();
  i2c_write_byte(HMC6352_WRITE);
  i2c_write_byte(END_CALIB);
  i2c_stop();
  delay_us(END_CALIB_DELAY);
}
//--------------------------------------------------------
void Calibrate_Compass(char CalibSpeed)
{
  unsigned int i,s,t;
  if (CompassType<1)
    return;
  //vector a,m;
  if (CalibSpeed==0)
    CalibSpeed=(MoveToMax+MoveToMin)/2;
  if(CompassType==1)
    {
    motors(0,0); // make sure motors are off
    delay_ms(300);
    Start_Calibration();
    s=CalibSpeed;
    motors(-s,s);
    for(i=0;i<2000;i++)
      RunMotors();
    motors(0,0);
    RunMotors();
    Finish_Calibration();
Calibrated = 1;
    }
  else
    {
     // calibrate compass #2
    xOffset=yOffset=0;
    t=Read_Compass();
    xMin=360;
    xMax=0; 
    yMin=360;
    yMax=0; 
    // z not needed
    motors(0,0); // make sure motors are off
    delay_ms(300);
    s=CalibSpeed;
    motors(-s,s);
    for(i=0;i<1500;i++)
      {
      t=Read_Compass();
      if (!((abs(xCur) > 600) || (abs(yCur) > 600)))
        {
        if(xCur>xMax) xMax=xCur;
        if(xCur<xMin) xMin=xCur;
        if(yCur>yMax) yMax=yCur;
        if(yCur<yMin) yMin=yCur;
        }
      RunMotors();
      }
    xOffset=(xMax+xMin)/2;
    yOffset=(yMax+yMin)/2;
    // y not needed
    motors(0,0);
    RunMotors();
Calibrated = 1;
    }
}
//--------------------------------------------------------

    
      
        
 

void InitI2C(void)
{

DDRC  |=  0b00110000;   //((1 << PORTC4) | (1 << PORTC5));
PORTC &= ~0b00110000;   // = 0;  // make bits low when port is an output
DDRC  &= ~0b00110000;                            
PORTC |=  0b00110000;   // (1 << PORTC4) | (1 << PORTC5); // enable pull-ups on SDA and SCL, respectively
TWSR = 0;  // clear bit-rate prescale bits
TWBR = 17*10; // produces an SCL frequency of 400 kHz with a 20 MHz CPU clock speed
return;
    // Compass I/O setup is special as the compass is I2C so both ports must float
    // Initial data is set LOW so any time the PIN is an OUTPUT, it will be LOW
    // When a PIN floats, EXTERNAL pull-up's allow it to appear HIGH
	   DDRB  |=  (1<<CompassClock);        // make both pins output
	   DDRB  |=  (1<<CompassData);         // so we can set the DATA register
	   PORTB &= ~(1<<CompassClock);   // Set both outputs LOW
	   PORTB &= ~(1<<CompassData);
	   DDRB  &= ~(1<<CompassClock);   // Set both to INPUT so they FLOAT
	   DDRB  &= ~(1<<CompassData);
//       PORTB |= (1<<CompassClock);
//       PORTB |= (1<<CompassData);
}


